

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.GtkSource.Interfaces.UndoManager
    ( 

-- * Exported types
    UndoManager(..)                         ,
    noUndoManager                           ,
    IsUndoManager                           ,
    toUndoManager                           ,


 -- * Methods
-- ** beginNotUndoableAction #method:beginNotUndoableAction#

#if ENABLE_OVERLOADING
    UndoManagerBeginNotUndoableActionMethodInfo,
#endif
    undoManagerBeginNotUndoableAction       ,


-- ** canRedo #method:canRedo#

#if ENABLE_OVERLOADING
    UndoManagerCanRedoMethodInfo            ,
#endif
    undoManagerCanRedo                      ,


-- ** canRedoChanged #method:canRedoChanged#

#if ENABLE_OVERLOADING
    UndoManagerCanRedoChangedMethodInfo     ,
#endif
    undoManagerCanRedoChanged               ,


-- ** canUndo #method:canUndo#

#if ENABLE_OVERLOADING
    UndoManagerCanUndoMethodInfo            ,
#endif
    undoManagerCanUndo                      ,


-- ** canUndoChanged #method:canUndoChanged#

#if ENABLE_OVERLOADING
    UndoManagerCanUndoChangedMethodInfo     ,
#endif
    undoManagerCanUndoChanged               ,


-- ** endNotUndoableAction #method:endNotUndoableAction#

#if ENABLE_OVERLOADING
    UndoManagerEndNotUndoableActionMethodInfo,
#endif
    undoManagerEndNotUndoableAction         ,


-- ** redo #method:redo#

#if ENABLE_OVERLOADING
    UndoManagerRedoMethodInfo               ,
#endif
    undoManagerRedo                         ,


-- ** undo #method:undo#

#if ENABLE_OVERLOADING
    UndoManagerUndoMethodInfo               ,
#endif
    undoManagerUndo                         ,




 -- * Signals
-- ** canRedoChanged #signal:canRedoChanged#

    C_UndoManagerCanRedoChangedCallback     ,
    UndoManagerCanRedoChangedCallback       ,
#if ENABLE_OVERLOADING
    UndoManagerCanRedoChangedSignalInfo     ,
#endif
    afterUndoManagerCanRedoChanged          ,
    genClosure_UndoManagerCanRedoChanged    ,
    mk_UndoManagerCanRedoChangedCallback    ,
    noUndoManagerCanRedoChangedCallback     ,
    onUndoManagerCanRedoChanged             ,
    wrap_UndoManagerCanRedoChangedCallback  ,


-- ** canUndoChanged #signal:canUndoChanged#

    C_UndoManagerCanUndoChangedCallback     ,
    UndoManagerCanUndoChangedCallback       ,
#if ENABLE_OVERLOADING
    UndoManagerCanUndoChangedSignalInfo     ,
#endif
    afterUndoManagerCanUndoChanged          ,
    genClosure_UndoManagerCanUndoChanged    ,
    mk_UndoManagerCanUndoChangedCallback    ,
    noUndoManagerCanUndoChangedCallback     ,
    onUndoManagerCanUndoChanged             ,
    wrap_UndoManagerCanUndoChangedCallback  ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.GObject.Objects.Object as GObject.Object

-- interface UndoManager 
-- | Memory-managed wrapper type.
newtype UndoManager = UndoManager (ManagedPtr UndoManager)
-- | A convenience alias for `Nothing` :: `Maybe` `UndoManager`.
noUndoManager :: Maybe UndoManager
noUndoManager = Nothing

-- signal UndoManager::can-redo-changed
{- |
Emitted when the ability to redo has changed.

/Since: 2.10/
-}
type UndoManagerCanRedoChangedCallback =
    IO ()

-- | A convenience synonym for @`Nothing` :: `Maybe` `UndoManagerCanRedoChangedCallback`@.
noUndoManagerCanRedoChangedCallback :: Maybe UndoManagerCanRedoChangedCallback
noUndoManagerCanRedoChangedCallback = Nothing

-- | Type for the callback on the (unwrapped) C side.
type C_UndoManagerCanRedoChangedCallback =
    Ptr () ->                               -- object
    Ptr () ->                               -- user_data
    IO ()

-- | Generate a function pointer callable from C code, from a `C_UndoManagerCanRedoChangedCallback`.
foreign import ccall "wrapper"
    mk_UndoManagerCanRedoChangedCallback :: C_UndoManagerCanRedoChangedCallback -> IO (FunPtr C_UndoManagerCanRedoChangedCallback)

-- | Wrap the callback into a `GClosure`.
genClosure_UndoManagerCanRedoChanged :: MonadIO m => UndoManagerCanRedoChangedCallback -> m (GClosure C_UndoManagerCanRedoChangedCallback)
genClosure_UndoManagerCanRedoChanged cb = liftIO $ do
    let cb' = wrap_UndoManagerCanRedoChangedCallback cb
    mk_UndoManagerCanRedoChangedCallback cb' >>= B.GClosure.newGClosure


-- | Wrap a `UndoManagerCanRedoChangedCallback` into a `C_UndoManagerCanRedoChangedCallback`.
wrap_UndoManagerCanRedoChangedCallback ::
    UndoManagerCanRedoChangedCallback ->
    C_UndoManagerCanRedoChangedCallback
wrap_UndoManagerCanRedoChangedCallback _cb _ _ = do
    _cb 


{- |
Connect a signal handler for the “@can-redo-changed@” signal, to be run before the default handler.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Signals.on' undoManager #canRedoChanged callback
@
-}
onUndoManagerCanRedoChanged :: (IsUndoManager a, MonadIO m) => a -> UndoManagerCanRedoChangedCallback -> m SignalHandlerId
onUndoManagerCanRedoChanged obj cb = liftIO $ do
    let cb' = wrap_UndoManagerCanRedoChangedCallback cb
    cb'' <- mk_UndoManagerCanRedoChangedCallback cb'
    connectSignalFunPtr obj "can-redo-changed" cb'' SignalConnectBefore

{- |
Connect a signal handler for the “@can-redo-changed@” signal, to be run after the default handler.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Signals.after' undoManager #canRedoChanged callback
@
-}
afterUndoManagerCanRedoChanged :: (IsUndoManager a, MonadIO m) => a -> UndoManagerCanRedoChangedCallback -> m SignalHandlerId
afterUndoManagerCanRedoChanged obj cb = liftIO $ do
    let cb' = wrap_UndoManagerCanRedoChangedCallback cb
    cb'' <- mk_UndoManagerCanRedoChangedCallback cb'
    connectSignalFunPtr obj "can-redo-changed" cb'' SignalConnectAfter


-- signal UndoManager::can-undo-changed
{- |
Emitted when the ability to undo has changed.

/Since: 2.10/
-}
type UndoManagerCanUndoChangedCallback =
    IO ()

-- | A convenience synonym for @`Nothing` :: `Maybe` `UndoManagerCanUndoChangedCallback`@.
noUndoManagerCanUndoChangedCallback :: Maybe UndoManagerCanUndoChangedCallback
noUndoManagerCanUndoChangedCallback = Nothing

-- | Type for the callback on the (unwrapped) C side.
type C_UndoManagerCanUndoChangedCallback =
    Ptr () ->                               -- object
    Ptr () ->                               -- user_data
    IO ()

-- | Generate a function pointer callable from C code, from a `C_UndoManagerCanUndoChangedCallback`.
foreign import ccall "wrapper"
    mk_UndoManagerCanUndoChangedCallback :: C_UndoManagerCanUndoChangedCallback -> IO (FunPtr C_UndoManagerCanUndoChangedCallback)

-- | Wrap the callback into a `GClosure`.
genClosure_UndoManagerCanUndoChanged :: MonadIO m => UndoManagerCanUndoChangedCallback -> m (GClosure C_UndoManagerCanUndoChangedCallback)
genClosure_UndoManagerCanUndoChanged cb = liftIO $ do
    let cb' = wrap_UndoManagerCanUndoChangedCallback cb
    mk_UndoManagerCanUndoChangedCallback cb' >>= B.GClosure.newGClosure


-- | Wrap a `UndoManagerCanUndoChangedCallback` into a `C_UndoManagerCanUndoChangedCallback`.
wrap_UndoManagerCanUndoChangedCallback ::
    UndoManagerCanUndoChangedCallback ->
    C_UndoManagerCanUndoChangedCallback
wrap_UndoManagerCanUndoChangedCallback _cb _ _ = do
    _cb 


{- |
Connect a signal handler for the “@can-undo-changed@” signal, to be run before the default handler.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Signals.on' undoManager #canUndoChanged callback
@
-}
onUndoManagerCanUndoChanged :: (IsUndoManager a, MonadIO m) => a -> UndoManagerCanUndoChangedCallback -> m SignalHandlerId
onUndoManagerCanUndoChanged obj cb = liftIO $ do
    let cb' = wrap_UndoManagerCanUndoChangedCallback cb
    cb'' <- mk_UndoManagerCanUndoChangedCallback cb'
    connectSignalFunPtr obj "can-undo-changed" cb'' SignalConnectBefore

{- |
Connect a signal handler for the “@can-undo-changed@” signal, to be run after the default handler.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Signals.after' undoManager #canUndoChanged callback
@
-}
afterUndoManagerCanUndoChanged :: (IsUndoManager a, MonadIO m) => a -> UndoManagerCanUndoChangedCallback -> m SignalHandlerId
afterUndoManagerCanUndoChanged obj cb = liftIO $ do
    let cb' = wrap_UndoManagerCanUndoChangedCallback cb
    cb'' <- mk_UndoManagerCanUndoChangedCallback cb'
    connectSignalFunPtr obj "can-undo-changed" cb'' SignalConnectAfter


#if ENABLE_OVERLOADING
data UndoManagerCanRedoChangedSignalInfo
instance SignalInfo UndoManagerCanRedoChangedSignalInfo where
    type HaskellCallbackType UndoManagerCanRedoChangedSignalInfo = UndoManagerCanRedoChangedCallback
    connectSignal _ obj cb connectMode = do
        let cb' = wrap_UndoManagerCanRedoChangedCallback cb
        cb'' <- mk_UndoManagerCanRedoChangedCallback cb'
        connectSignalFunPtr obj "can-redo-changed" cb'' connectMode

data UndoManagerCanUndoChangedSignalInfo
instance SignalInfo UndoManagerCanUndoChangedSignalInfo where
    type HaskellCallbackType UndoManagerCanUndoChangedSignalInfo = UndoManagerCanUndoChangedCallback
    connectSignal _ obj cb connectMode = do
        let cb' = wrap_UndoManagerCanUndoChangedCallback cb
        cb'' <- mk_UndoManagerCanUndoChangedCallback cb'
        connectSignalFunPtr obj "can-undo-changed" cb'' connectMode

type instance O.SignalList UndoManager = UndoManagerSignalList
type UndoManagerSignalList = ('[ '("canRedoChanged", UndoManagerCanRedoChangedSignalInfo), '("canUndoChanged", UndoManagerCanUndoChangedSignalInfo), '("notify", GObject.Object.ObjectNotifySignalInfo)] :: [(Symbol, *)])

#endif

foreign import ccall "gtk_source_undo_manager_get_type"
    c_gtk_source_undo_manager_get_type :: IO GType

instance GObject UndoManager where
    gobjectType = c_gtk_source_undo_manager_get_type
    

-- | Type class for types which can be safely cast to `UndoManager`, for instance with `toUndoManager`.
class (GObject o, O.IsDescendantOf UndoManager o) => IsUndoManager o
instance (GObject o, O.IsDescendantOf UndoManager o) => IsUndoManager o

instance O.HasParentTypes UndoManager
type instance O.ParentTypes UndoManager = '[GObject.Object.Object]

-- | Cast to `UndoManager`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toUndoManager :: (MonadIO m, IsUndoManager o) => o -> m UndoManager
toUndoManager = liftIO . unsafeCastTo UndoManager

#if ENABLE_OVERLOADING
instance O.HasAttributeList UndoManager
type instance O.AttributeList UndoManager = UndoManagerAttributeList
type UndoManagerAttributeList = ('[ ] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
#endif

#if ENABLE_OVERLOADING
type family ResolveUndoManagerMethod (t :: Symbol) (o :: *) :: * where
    ResolveUndoManagerMethod "beginNotUndoableAction" o = UndoManagerBeginNotUndoableActionMethodInfo
    ResolveUndoManagerMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveUndoManagerMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveUndoManagerMethod "canRedo" o = UndoManagerCanRedoMethodInfo
    ResolveUndoManagerMethod "canRedoChanged" o = UndoManagerCanRedoChangedMethodInfo
    ResolveUndoManagerMethod "canUndo" o = UndoManagerCanUndoMethodInfo
    ResolveUndoManagerMethod "canUndoChanged" o = UndoManagerCanUndoChangedMethodInfo
    ResolveUndoManagerMethod "endNotUndoableAction" o = UndoManagerEndNotUndoableActionMethodInfo
    ResolveUndoManagerMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveUndoManagerMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveUndoManagerMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveUndoManagerMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveUndoManagerMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveUndoManagerMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveUndoManagerMethod "redo" o = UndoManagerRedoMethodInfo
    ResolveUndoManagerMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveUndoManagerMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveUndoManagerMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveUndoManagerMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveUndoManagerMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveUndoManagerMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveUndoManagerMethod "undo" o = UndoManagerUndoMethodInfo
    ResolveUndoManagerMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveUndoManagerMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveUndoManagerMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveUndoManagerMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveUndoManagerMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveUndoManagerMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveUndoManagerMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveUndoManagerMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveUndoManagerMethod t UndoManager, O.MethodInfo info UndoManager p) => OL.IsLabel t (UndoManager -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

-- method UndoManager::begin_not_undoable_action
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "manager", argType = TInterface (Name {namespace = "GtkSource", name = "UndoManager"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GtkSourceUndoManager.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "gtk_source_undo_manager_begin_not_undoable_action" gtk_source_undo_manager_begin_not_undoable_action :: 
    Ptr UndoManager ->                      -- manager : TInterface (Name {namespace = "GtkSource", name = "UndoManager"})
    IO ()

{- |
Begin a not undoable action on the buffer. All changes between this call
and the call to 'GI.GtkSource.Interfaces.UndoManager.undoManagerEndNotUndoableAction' cannot
be undone. This function should be re-entrant.

/Since: 2.10/
-}
undoManagerBeginNotUndoableAction ::
    (B.CallStack.HasCallStack, MonadIO m, IsUndoManager a) =>
    a
    {- ^ /@manager@/: a 'GI.GtkSource.Interfaces.UndoManager.UndoManager'. -}
    -> m ()
undoManagerBeginNotUndoableAction manager = liftIO $ do
    manager' <- unsafeManagedPtrCastPtr manager
    gtk_source_undo_manager_begin_not_undoable_action manager'
    touchManagedPtr manager
    return ()

#if ENABLE_OVERLOADING
data UndoManagerBeginNotUndoableActionMethodInfo
instance (signature ~ (m ()), MonadIO m, IsUndoManager a) => O.MethodInfo UndoManagerBeginNotUndoableActionMethodInfo a signature where
    overloadedMethod _ = undoManagerBeginNotUndoableAction

#endif

-- method UndoManager::can_redo
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "manager", argType = TInterface (Name {namespace = "GtkSource", name = "UndoManager"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GtkSourceUndoManager.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "gtk_source_undo_manager_can_redo" gtk_source_undo_manager_can_redo :: 
    Ptr UndoManager ->                      -- manager : TInterface (Name {namespace = "GtkSource", name = "UndoManager"})
    IO CInt

{- |
Get whether there are redo operations available.

/Since: 2.10/
-}
undoManagerCanRedo ::
    (B.CallStack.HasCallStack, MonadIO m, IsUndoManager a) =>
    a
    {- ^ /@manager@/: a 'GI.GtkSource.Interfaces.UndoManager.UndoManager'. -}
    -> m Bool
    {- ^ __Returns:__ 'True' if there are redo operations available, 'False' otherwise -}
undoManagerCanRedo manager = liftIO $ do
    manager' <- unsafeManagedPtrCastPtr manager
    result <- gtk_source_undo_manager_can_redo manager'
    let result' = (/= 0) result
    touchManagedPtr manager
    return result'

#if ENABLE_OVERLOADING
data UndoManagerCanRedoMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsUndoManager a) => O.MethodInfo UndoManagerCanRedoMethodInfo a signature where
    overloadedMethod _ = undoManagerCanRedo

#endif

-- method UndoManager::can_redo_changed
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "manager", argType = TInterface (Name {namespace = "GtkSource", name = "UndoManager"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GtkSourceUndoManager.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "gtk_source_undo_manager_can_redo_changed" gtk_source_undo_manager_can_redo_changed :: 
    Ptr UndoManager ->                      -- manager : TInterface (Name {namespace = "GtkSource", name = "UndoManager"})
    IO ()

{- |
Emits the 'GI.GtkSource.Interfaces.UndoManager.UndoManager'::@/can-redo-changed/@ signal.

/Since: 2.10/
-}
undoManagerCanRedoChanged ::
    (B.CallStack.HasCallStack, MonadIO m, IsUndoManager a) =>
    a
    {- ^ /@manager@/: a 'GI.GtkSource.Interfaces.UndoManager.UndoManager'. -}
    -> m ()
undoManagerCanRedoChanged manager = liftIO $ do
    manager' <- unsafeManagedPtrCastPtr manager
    gtk_source_undo_manager_can_redo_changed manager'
    touchManagedPtr manager
    return ()

#if ENABLE_OVERLOADING
data UndoManagerCanRedoChangedMethodInfo
instance (signature ~ (m ()), MonadIO m, IsUndoManager a) => O.MethodInfo UndoManagerCanRedoChangedMethodInfo a signature where
    overloadedMethod _ = undoManagerCanRedoChanged

#endif

-- method UndoManager::can_undo
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "manager", argType = TInterface (Name {namespace = "GtkSource", name = "UndoManager"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GtkSourceUndoManager.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "gtk_source_undo_manager_can_undo" gtk_source_undo_manager_can_undo :: 
    Ptr UndoManager ->                      -- manager : TInterface (Name {namespace = "GtkSource", name = "UndoManager"})
    IO CInt

{- |
Get whether there are undo operations available.

/Since: 2.10/
-}
undoManagerCanUndo ::
    (B.CallStack.HasCallStack, MonadIO m, IsUndoManager a) =>
    a
    {- ^ /@manager@/: a 'GI.GtkSource.Interfaces.UndoManager.UndoManager'. -}
    -> m Bool
    {- ^ __Returns:__ 'True' if there are undo operations available, 'False' otherwise -}
undoManagerCanUndo manager = liftIO $ do
    manager' <- unsafeManagedPtrCastPtr manager
    result <- gtk_source_undo_manager_can_undo manager'
    let result' = (/= 0) result
    touchManagedPtr manager
    return result'

#if ENABLE_OVERLOADING
data UndoManagerCanUndoMethodInfo
instance (signature ~ (m Bool), MonadIO m, IsUndoManager a) => O.MethodInfo UndoManagerCanUndoMethodInfo a signature where
    overloadedMethod _ = undoManagerCanUndo

#endif

-- method UndoManager::can_undo_changed
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "manager", argType = TInterface (Name {namespace = "GtkSource", name = "UndoManager"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GtkSourceUndoManager.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "gtk_source_undo_manager_can_undo_changed" gtk_source_undo_manager_can_undo_changed :: 
    Ptr UndoManager ->                      -- manager : TInterface (Name {namespace = "GtkSource", name = "UndoManager"})
    IO ()

{- |
Emits the 'GI.GtkSource.Interfaces.UndoManager.UndoManager'::@/can-undo-changed/@ signal.

/Since: 2.10/
-}
undoManagerCanUndoChanged ::
    (B.CallStack.HasCallStack, MonadIO m, IsUndoManager a) =>
    a
    {- ^ /@manager@/: a 'GI.GtkSource.Interfaces.UndoManager.UndoManager'. -}
    -> m ()
undoManagerCanUndoChanged manager = liftIO $ do
    manager' <- unsafeManagedPtrCastPtr manager
    gtk_source_undo_manager_can_undo_changed manager'
    touchManagedPtr manager
    return ()

#if ENABLE_OVERLOADING
data UndoManagerCanUndoChangedMethodInfo
instance (signature ~ (m ()), MonadIO m, IsUndoManager a) => O.MethodInfo UndoManagerCanUndoChangedMethodInfo a signature where
    overloadedMethod _ = undoManagerCanUndoChanged

#endif

-- method UndoManager::end_not_undoable_action
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "manager", argType = TInterface (Name {namespace = "GtkSource", name = "UndoManager"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GtkSourceUndoManager.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "gtk_source_undo_manager_end_not_undoable_action" gtk_source_undo_manager_end_not_undoable_action :: 
    Ptr UndoManager ->                      -- manager : TInterface (Name {namespace = "GtkSource", name = "UndoManager"})
    IO ()

{- |
Ends a not undoable action on the buffer.

/Since: 2.10/
-}
undoManagerEndNotUndoableAction ::
    (B.CallStack.HasCallStack, MonadIO m, IsUndoManager a) =>
    a
    {- ^ /@manager@/: a 'GI.GtkSource.Interfaces.UndoManager.UndoManager'. -}
    -> m ()
undoManagerEndNotUndoableAction manager = liftIO $ do
    manager' <- unsafeManagedPtrCastPtr manager
    gtk_source_undo_manager_end_not_undoable_action manager'
    touchManagedPtr manager
    return ()

#if ENABLE_OVERLOADING
data UndoManagerEndNotUndoableActionMethodInfo
instance (signature ~ (m ()), MonadIO m, IsUndoManager a) => O.MethodInfo UndoManagerEndNotUndoableActionMethodInfo a signature where
    overloadedMethod _ = undoManagerEndNotUndoableAction

#endif

-- method UndoManager::redo
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "manager", argType = TInterface (Name {namespace = "GtkSource", name = "UndoManager"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GtkSourceUndoManager.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "gtk_source_undo_manager_redo" gtk_source_undo_manager_redo :: 
    Ptr UndoManager ->                      -- manager : TInterface (Name {namespace = "GtkSource", name = "UndoManager"})
    IO ()

{- |
Perform a single redo. Calling this function when there are no redo operations
available is an error. Use 'GI.GtkSource.Interfaces.UndoManager.undoManagerCanRedo' to find out
if there are redo operations available.

/Since: 2.10/
-}
undoManagerRedo ::
    (B.CallStack.HasCallStack, MonadIO m, IsUndoManager a) =>
    a
    {- ^ /@manager@/: a 'GI.GtkSource.Interfaces.UndoManager.UndoManager'. -}
    -> m ()
undoManagerRedo manager = liftIO $ do
    manager' <- unsafeManagedPtrCastPtr manager
    gtk_source_undo_manager_redo manager'
    touchManagedPtr manager
    return ()

#if ENABLE_OVERLOADING
data UndoManagerRedoMethodInfo
instance (signature ~ (m ()), MonadIO m, IsUndoManager a) => O.MethodInfo UndoManagerRedoMethodInfo a signature where
    overloadedMethod _ = undoManagerRedo

#endif

-- method UndoManager::undo
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "manager", argType = TInterface (Name {namespace = "GtkSource", name = "UndoManager"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GtkSourceUndoManager.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "gtk_source_undo_manager_undo" gtk_source_undo_manager_undo :: 
    Ptr UndoManager ->                      -- manager : TInterface (Name {namespace = "GtkSource", name = "UndoManager"})
    IO ()

{- |
Perform a single undo. Calling this function when there are no undo operations
available is an error. Use 'GI.GtkSource.Interfaces.UndoManager.undoManagerCanUndo' to find out
if there are undo operations available.

/Since: 2.10/
-}
undoManagerUndo ::
    (B.CallStack.HasCallStack, MonadIO m, IsUndoManager a) =>
    a
    {- ^ /@manager@/: a 'GI.GtkSource.Interfaces.UndoManager.UndoManager'. -}
    -> m ()
undoManagerUndo manager = liftIO $ do
    manager' <- unsafeManagedPtrCastPtr manager
    gtk_source_undo_manager_undo manager'
    touchManagedPtr manager
    return ()

#if ENABLE_OVERLOADING
data UndoManagerUndoMethodInfo
instance (signature ~ (m ()), MonadIO m, IsUndoManager a) => O.MethodInfo UndoManagerUndoMethodInfo a signature where
    overloadedMethod _ = undoManagerUndo

#endif


