

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.GtkSource.Objects.CompletionInfo
    ( 

-- * Exported types
    CompletionInfo(..)                      ,
    IsCompletionInfo                        ,
    toCompletionInfo                        ,
    noCompletionInfo                        ,


 -- * Methods
-- ** getWidget #method:getWidget#

#if ENABLE_OVERLOADING
    CompletionInfoGetWidgetMethodInfo       ,
#endif
    completionInfoGetWidget                 ,


-- ** moveToIter #method:moveToIter#

#if ENABLE_OVERLOADING
    CompletionInfoMoveToIterMethodInfo      ,
#endif
    completionInfoMoveToIter                ,


-- ** new #method:new#

    completionInfoNew                       ,


-- ** setWidget #method:setWidget#

#if ENABLE_OVERLOADING
    CompletionInfoSetWidgetMethodInfo       ,
#endif
    completionInfoSetWidget                 ,




 -- * Signals
-- ** beforeShow #signal:beforeShow#

    C_CompletionInfoBeforeShowCallback      ,
    CompletionInfoBeforeShowCallback        ,
#if ENABLE_OVERLOADING
    CompletionInfoBeforeShowSignalInfo      ,
#endif
    afterCompletionInfoBeforeShow           ,
    genClosure_CompletionInfoBeforeShow     ,
    mk_CompletionInfoBeforeShowCallback     ,
    noCompletionInfoBeforeShowCallback      ,
    onCompletionInfoBeforeShow              ,
    wrap_CompletionInfoBeforeShowCallback   ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.Atk.Interfaces.ImplementorIface as Atk.ImplementorIface
import qualified GI.GObject.Objects.Object as GObject.Object
import qualified GI.Gtk.Interfaces.Buildable as Gtk.Buildable
import qualified GI.Gtk.Objects.Bin as Gtk.Bin
import qualified GI.Gtk.Objects.Container as Gtk.Container
import qualified GI.Gtk.Objects.TextView as Gtk.TextView
import qualified GI.Gtk.Objects.Widget as Gtk.Widget
import qualified GI.Gtk.Objects.Window as Gtk.Window
import qualified GI.Gtk.Structs.TextIter as Gtk.TextIter

-- | Memory-managed wrapper type.
newtype CompletionInfo = CompletionInfo (ManagedPtr CompletionInfo)
foreign import ccall "gtk_source_completion_info_get_type"
    c_gtk_source_completion_info_get_type :: IO GType

instance GObject CompletionInfo where
    gobjectType = c_gtk_source_completion_info_get_type
    

-- | Type class for types which can be safely cast to `CompletionInfo`, for instance with `toCompletionInfo`.
class (GObject o, O.IsDescendantOf CompletionInfo o) => IsCompletionInfo o
instance (GObject o, O.IsDescendantOf CompletionInfo o) => IsCompletionInfo o

instance O.HasParentTypes CompletionInfo
type instance O.ParentTypes CompletionInfo = '[Gtk.Window.Window, Gtk.Bin.Bin, Gtk.Container.Container, Gtk.Widget.Widget, GObject.Object.Object, Atk.ImplementorIface.ImplementorIface, Gtk.Buildable.Buildable]

-- | Cast to `CompletionInfo`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toCompletionInfo :: (MonadIO m, IsCompletionInfo o) => o -> m CompletionInfo
toCompletionInfo = liftIO . unsafeCastTo CompletionInfo

-- | A convenience alias for `Nothing` :: `Maybe` `CompletionInfo`.
noCompletionInfo :: Maybe CompletionInfo
noCompletionInfo = Nothing

#if ENABLE_OVERLOADING
type family ResolveCompletionInfoMethod (t :: Symbol) (o :: *) :: * where
    ResolveCompletionInfoMethod "activate" o = Gtk.Widget.WidgetActivateMethodInfo
    ResolveCompletionInfoMethod "activateDefault" o = Gtk.Window.WindowActivateDefaultMethodInfo
    ResolveCompletionInfoMethod "activateFocus" o = Gtk.Window.WindowActivateFocusMethodInfo
    ResolveCompletionInfoMethod "activateKey" o = Gtk.Window.WindowActivateKeyMethodInfo
    ResolveCompletionInfoMethod "add" o = Gtk.Container.ContainerAddMethodInfo
    ResolveCompletionInfoMethod "addAccelGroup" o = Gtk.Window.WindowAddAccelGroupMethodInfo
    ResolveCompletionInfoMethod "addAccelerator" o = Gtk.Widget.WidgetAddAcceleratorMethodInfo
    ResolveCompletionInfoMethod "addChild" o = Gtk.Buildable.BuildableAddChildMethodInfo
    ResolveCompletionInfoMethod "addDeviceEvents" o = Gtk.Widget.WidgetAddDeviceEventsMethodInfo
    ResolveCompletionInfoMethod "addEvents" o = Gtk.Widget.WidgetAddEventsMethodInfo
    ResolveCompletionInfoMethod "addMnemonic" o = Gtk.Window.WindowAddMnemonicMethodInfo
    ResolveCompletionInfoMethod "addMnemonicLabel" o = Gtk.Widget.WidgetAddMnemonicLabelMethodInfo
    ResolveCompletionInfoMethod "addTickCallback" o = Gtk.Widget.WidgetAddTickCallbackMethodInfo
    ResolveCompletionInfoMethod "beginMoveDrag" o = Gtk.Window.WindowBeginMoveDragMethodInfo
    ResolveCompletionInfoMethod "beginResizeDrag" o = Gtk.Window.WindowBeginResizeDragMethodInfo
    ResolveCompletionInfoMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveCompletionInfoMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveCompletionInfoMethod "canActivateAccel" o = Gtk.Widget.WidgetCanActivateAccelMethodInfo
    ResolveCompletionInfoMethod "checkResize" o = Gtk.Container.ContainerCheckResizeMethodInfo
    ResolveCompletionInfoMethod "childFocus" o = Gtk.Widget.WidgetChildFocusMethodInfo
    ResolveCompletionInfoMethod "childGetProperty" o = Gtk.Container.ContainerChildGetPropertyMethodInfo
    ResolveCompletionInfoMethod "childNotify" o = Gtk.Container.ContainerChildNotifyMethodInfo
    ResolveCompletionInfoMethod "childNotifyByPspec" o = Gtk.Container.ContainerChildNotifyByPspecMethodInfo
    ResolveCompletionInfoMethod "childSetProperty" o = Gtk.Container.ContainerChildSetPropertyMethodInfo
    ResolveCompletionInfoMethod "childType" o = Gtk.Container.ContainerChildTypeMethodInfo
    ResolveCompletionInfoMethod "classPath" o = Gtk.Widget.WidgetClassPathMethodInfo
    ResolveCompletionInfoMethod "close" o = Gtk.Window.WindowCloseMethodInfo
    ResolveCompletionInfoMethod "computeExpand" o = Gtk.Widget.WidgetComputeExpandMethodInfo
    ResolveCompletionInfoMethod "constructChild" o = Gtk.Buildable.BuildableConstructChildMethodInfo
    ResolveCompletionInfoMethod "createPangoContext" o = Gtk.Widget.WidgetCreatePangoContextMethodInfo
    ResolveCompletionInfoMethod "createPangoLayout" o = Gtk.Widget.WidgetCreatePangoLayoutMethodInfo
    ResolveCompletionInfoMethod "customFinished" o = Gtk.Buildable.BuildableCustomFinishedMethodInfo
    ResolveCompletionInfoMethod "customTagEnd" o = Gtk.Buildable.BuildableCustomTagEndMethodInfo
    ResolveCompletionInfoMethod "customTagStart" o = Gtk.Buildable.BuildableCustomTagStartMethodInfo
    ResolveCompletionInfoMethod "deiconify" o = Gtk.Window.WindowDeiconifyMethodInfo
    ResolveCompletionInfoMethod "destroy" o = Gtk.Widget.WidgetDestroyMethodInfo
    ResolveCompletionInfoMethod "destroyed" o = Gtk.Widget.WidgetDestroyedMethodInfo
    ResolveCompletionInfoMethod "deviceIsShadowed" o = Gtk.Widget.WidgetDeviceIsShadowedMethodInfo
    ResolveCompletionInfoMethod "dragBegin" o = Gtk.Widget.WidgetDragBeginMethodInfo
    ResolveCompletionInfoMethod "dragBeginWithCoordinates" o = Gtk.Widget.WidgetDragBeginWithCoordinatesMethodInfo
    ResolveCompletionInfoMethod "dragCheckThreshold" o = Gtk.Widget.WidgetDragCheckThresholdMethodInfo
    ResolveCompletionInfoMethod "dragDestAddImageTargets" o = Gtk.Widget.WidgetDragDestAddImageTargetsMethodInfo
    ResolveCompletionInfoMethod "dragDestAddTextTargets" o = Gtk.Widget.WidgetDragDestAddTextTargetsMethodInfo
    ResolveCompletionInfoMethod "dragDestAddUriTargets" o = Gtk.Widget.WidgetDragDestAddUriTargetsMethodInfo
    ResolveCompletionInfoMethod "dragDestFindTarget" o = Gtk.Widget.WidgetDragDestFindTargetMethodInfo
    ResolveCompletionInfoMethod "dragDestGetTargetList" o = Gtk.Widget.WidgetDragDestGetTargetListMethodInfo
    ResolveCompletionInfoMethod "dragDestGetTrackMotion" o = Gtk.Widget.WidgetDragDestGetTrackMotionMethodInfo
    ResolveCompletionInfoMethod "dragDestSet" o = Gtk.Widget.WidgetDragDestSetMethodInfo
    ResolveCompletionInfoMethod "dragDestSetProxy" o = Gtk.Widget.WidgetDragDestSetProxyMethodInfo
    ResolveCompletionInfoMethod "dragDestSetTargetList" o = Gtk.Widget.WidgetDragDestSetTargetListMethodInfo
    ResolveCompletionInfoMethod "dragDestSetTrackMotion" o = Gtk.Widget.WidgetDragDestSetTrackMotionMethodInfo
    ResolveCompletionInfoMethod "dragDestUnset" o = Gtk.Widget.WidgetDragDestUnsetMethodInfo
    ResolveCompletionInfoMethod "dragGetData" o = Gtk.Widget.WidgetDragGetDataMethodInfo
    ResolveCompletionInfoMethod "dragHighlight" o = Gtk.Widget.WidgetDragHighlightMethodInfo
    ResolveCompletionInfoMethod "dragSourceAddImageTargets" o = Gtk.Widget.WidgetDragSourceAddImageTargetsMethodInfo
    ResolveCompletionInfoMethod "dragSourceAddTextTargets" o = Gtk.Widget.WidgetDragSourceAddTextTargetsMethodInfo
    ResolveCompletionInfoMethod "dragSourceAddUriTargets" o = Gtk.Widget.WidgetDragSourceAddUriTargetsMethodInfo
    ResolveCompletionInfoMethod "dragSourceGetTargetList" o = Gtk.Widget.WidgetDragSourceGetTargetListMethodInfo
    ResolveCompletionInfoMethod "dragSourceSet" o = Gtk.Widget.WidgetDragSourceSetMethodInfo
    ResolveCompletionInfoMethod "dragSourceSetIconGicon" o = Gtk.Widget.WidgetDragSourceSetIconGiconMethodInfo
    ResolveCompletionInfoMethod "dragSourceSetIconName" o = Gtk.Widget.WidgetDragSourceSetIconNameMethodInfo
    ResolveCompletionInfoMethod "dragSourceSetIconPixbuf" o = Gtk.Widget.WidgetDragSourceSetIconPixbufMethodInfo
    ResolveCompletionInfoMethod "dragSourceSetIconStock" o = Gtk.Widget.WidgetDragSourceSetIconStockMethodInfo
    ResolveCompletionInfoMethod "dragSourceSetTargetList" o = Gtk.Widget.WidgetDragSourceSetTargetListMethodInfo
    ResolveCompletionInfoMethod "dragSourceUnset" o = Gtk.Widget.WidgetDragSourceUnsetMethodInfo
    ResolveCompletionInfoMethod "dragUnhighlight" o = Gtk.Widget.WidgetDragUnhighlightMethodInfo
    ResolveCompletionInfoMethod "draw" o = Gtk.Widget.WidgetDrawMethodInfo
    ResolveCompletionInfoMethod "ensureStyle" o = Gtk.Widget.WidgetEnsureStyleMethodInfo
    ResolveCompletionInfoMethod "errorBell" o = Gtk.Widget.WidgetErrorBellMethodInfo
    ResolveCompletionInfoMethod "event" o = Gtk.Widget.WidgetEventMethodInfo
    ResolveCompletionInfoMethod "forall" o = Gtk.Container.ContainerForallMethodInfo
    ResolveCompletionInfoMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveCompletionInfoMethod "foreach" o = Gtk.Container.ContainerForeachMethodInfo
    ResolveCompletionInfoMethod "freezeChildNotify" o = Gtk.Widget.WidgetFreezeChildNotifyMethodInfo
    ResolveCompletionInfoMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveCompletionInfoMethod "fullscreen" o = Gtk.Window.WindowFullscreenMethodInfo
    ResolveCompletionInfoMethod "fullscreenOnMonitor" o = Gtk.Window.WindowFullscreenOnMonitorMethodInfo
    ResolveCompletionInfoMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveCompletionInfoMethod "grabAdd" o = Gtk.Widget.WidgetGrabAddMethodInfo
    ResolveCompletionInfoMethod "grabDefault" o = Gtk.Widget.WidgetGrabDefaultMethodInfo
    ResolveCompletionInfoMethod "grabFocus" o = Gtk.Widget.WidgetGrabFocusMethodInfo
    ResolveCompletionInfoMethod "grabRemove" o = Gtk.Widget.WidgetGrabRemoveMethodInfo
    ResolveCompletionInfoMethod "hasDefault" o = Gtk.Widget.WidgetHasDefaultMethodInfo
    ResolveCompletionInfoMethod "hasFocus" o = Gtk.Widget.WidgetHasFocusMethodInfo
    ResolveCompletionInfoMethod "hasGrab" o = Gtk.Widget.WidgetHasGrabMethodInfo
    ResolveCompletionInfoMethod "hasGroup" o = Gtk.Window.WindowHasGroupMethodInfo
    ResolveCompletionInfoMethod "hasRcStyle" o = Gtk.Widget.WidgetHasRcStyleMethodInfo
    ResolveCompletionInfoMethod "hasScreen" o = Gtk.Widget.WidgetHasScreenMethodInfo
    ResolveCompletionInfoMethod "hasToplevelFocus" o = Gtk.Window.WindowHasToplevelFocusMethodInfo
    ResolveCompletionInfoMethod "hasVisibleFocus" o = Gtk.Widget.WidgetHasVisibleFocusMethodInfo
    ResolveCompletionInfoMethod "hide" o = Gtk.Widget.WidgetHideMethodInfo
    ResolveCompletionInfoMethod "hideOnDelete" o = Gtk.Widget.WidgetHideOnDeleteMethodInfo
    ResolveCompletionInfoMethod "iconify" o = Gtk.Window.WindowIconifyMethodInfo
    ResolveCompletionInfoMethod "inDestruction" o = Gtk.Widget.WidgetInDestructionMethodInfo
    ResolveCompletionInfoMethod "initTemplate" o = Gtk.Widget.WidgetInitTemplateMethodInfo
    ResolveCompletionInfoMethod "inputShapeCombineRegion" o = Gtk.Widget.WidgetInputShapeCombineRegionMethodInfo
    ResolveCompletionInfoMethod "insertActionGroup" o = Gtk.Widget.WidgetInsertActionGroupMethodInfo
    ResolveCompletionInfoMethod "intersect" o = Gtk.Widget.WidgetIntersectMethodInfo
    ResolveCompletionInfoMethod "isActive" o = Gtk.Window.WindowIsActiveMethodInfo
    ResolveCompletionInfoMethod "isAncestor" o = Gtk.Widget.WidgetIsAncestorMethodInfo
    ResolveCompletionInfoMethod "isComposited" o = Gtk.Widget.WidgetIsCompositedMethodInfo
    ResolveCompletionInfoMethod "isDrawable" o = Gtk.Widget.WidgetIsDrawableMethodInfo
    ResolveCompletionInfoMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveCompletionInfoMethod "isFocus" o = Gtk.Widget.WidgetIsFocusMethodInfo
    ResolveCompletionInfoMethod "isMaximized" o = Gtk.Window.WindowIsMaximizedMethodInfo
    ResolveCompletionInfoMethod "isSensitive" o = Gtk.Widget.WidgetIsSensitiveMethodInfo
    ResolveCompletionInfoMethod "isToplevel" o = Gtk.Widget.WidgetIsToplevelMethodInfo
    ResolveCompletionInfoMethod "isVisible" o = Gtk.Widget.WidgetIsVisibleMethodInfo
    ResolveCompletionInfoMethod "keynavFailed" o = Gtk.Widget.WidgetKeynavFailedMethodInfo
    ResolveCompletionInfoMethod "listAccelClosures" o = Gtk.Widget.WidgetListAccelClosuresMethodInfo
    ResolveCompletionInfoMethod "listActionPrefixes" o = Gtk.Widget.WidgetListActionPrefixesMethodInfo
    ResolveCompletionInfoMethod "listMnemonicLabels" o = Gtk.Widget.WidgetListMnemonicLabelsMethodInfo
    ResolveCompletionInfoMethod "map" o = Gtk.Widget.WidgetMapMethodInfo
    ResolveCompletionInfoMethod "maximize" o = Gtk.Window.WindowMaximizeMethodInfo
    ResolveCompletionInfoMethod "mnemonicActivate" o = Gtk.Window.WindowMnemonicActivateMethodInfo
    ResolveCompletionInfoMethod "modifyBase" o = Gtk.Widget.WidgetModifyBaseMethodInfo
    ResolveCompletionInfoMethod "modifyBg" o = Gtk.Widget.WidgetModifyBgMethodInfo
    ResolveCompletionInfoMethod "modifyCursor" o = Gtk.Widget.WidgetModifyCursorMethodInfo
    ResolveCompletionInfoMethod "modifyFg" o = Gtk.Widget.WidgetModifyFgMethodInfo
    ResolveCompletionInfoMethod "modifyFont" o = Gtk.Widget.WidgetModifyFontMethodInfo
    ResolveCompletionInfoMethod "modifyStyle" o = Gtk.Widget.WidgetModifyStyleMethodInfo
    ResolveCompletionInfoMethod "modifyText" o = Gtk.Widget.WidgetModifyTextMethodInfo
    ResolveCompletionInfoMethod "move" o = Gtk.Window.WindowMoveMethodInfo
    ResolveCompletionInfoMethod "moveToIter" o = CompletionInfoMoveToIterMethodInfo
    ResolveCompletionInfoMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveCompletionInfoMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveCompletionInfoMethod "overrideBackgroundColor" o = Gtk.Widget.WidgetOverrideBackgroundColorMethodInfo
    ResolveCompletionInfoMethod "overrideColor" o = Gtk.Widget.WidgetOverrideColorMethodInfo
    ResolveCompletionInfoMethod "overrideCursor" o = Gtk.Widget.WidgetOverrideCursorMethodInfo
    ResolveCompletionInfoMethod "overrideFont" o = Gtk.Widget.WidgetOverrideFontMethodInfo
    ResolveCompletionInfoMethod "overrideSymbolicColor" o = Gtk.Widget.WidgetOverrideSymbolicColorMethodInfo
    ResolveCompletionInfoMethod "parseGeometry" o = Gtk.Window.WindowParseGeometryMethodInfo
    ResolveCompletionInfoMethod "parserFinished" o = Gtk.Buildable.BuildableParserFinishedMethodInfo
    ResolveCompletionInfoMethod "path" o = Gtk.Widget.WidgetPathMethodInfo
    ResolveCompletionInfoMethod "present" o = Gtk.Window.WindowPresentMethodInfo
    ResolveCompletionInfoMethod "presentWithTime" o = Gtk.Window.WindowPresentWithTimeMethodInfo
    ResolveCompletionInfoMethod "propagateDraw" o = Gtk.Container.ContainerPropagateDrawMethodInfo
    ResolveCompletionInfoMethod "propagateKeyEvent" o = Gtk.Window.WindowPropagateKeyEventMethodInfo
    ResolveCompletionInfoMethod "queueAllocate" o = Gtk.Widget.WidgetQueueAllocateMethodInfo
    ResolveCompletionInfoMethod "queueComputeExpand" o = Gtk.Widget.WidgetQueueComputeExpandMethodInfo
    ResolveCompletionInfoMethod "queueDraw" o = Gtk.Widget.WidgetQueueDrawMethodInfo
    ResolveCompletionInfoMethod "queueDrawArea" o = Gtk.Widget.WidgetQueueDrawAreaMethodInfo
    ResolveCompletionInfoMethod "queueDrawRegion" o = Gtk.Widget.WidgetQueueDrawRegionMethodInfo
    ResolveCompletionInfoMethod "queueResize" o = Gtk.Widget.WidgetQueueResizeMethodInfo
    ResolveCompletionInfoMethod "queueResizeNoRedraw" o = Gtk.Widget.WidgetQueueResizeNoRedrawMethodInfo
    ResolveCompletionInfoMethod "realize" o = Gtk.Widget.WidgetRealizeMethodInfo
    ResolveCompletionInfoMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveCompletionInfoMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveCompletionInfoMethod "regionIntersect" o = Gtk.Widget.WidgetRegionIntersectMethodInfo
    ResolveCompletionInfoMethod "registerWindow" o = Gtk.Widget.WidgetRegisterWindowMethodInfo
    ResolveCompletionInfoMethod "remove" o = Gtk.Container.ContainerRemoveMethodInfo
    ResolveCompletionInfoMethod "removeAccelGroup" o = Gtk.Window.WindowRemoveAccelGroupMethodInfo
    ResolveCompletionInfoMethod "removeAccelerator" o = Gtk.Widget.WidgetRemoveAcceleratorMethodInfo
    ResolveCompletionInfoMethod "removeMnemonic" o = Gtk.Window.WindowRemoveMnemonicMethodInfo
    ResolveCompletionInfoMethod "removeMnemonicLabel" o = Gtk.Widget.WidgetRemoveMnemonicLabelMethodInfo
    ResolveCompletionInfoMethod "removeTickCallback" o = Gtk.Widget.WidgetRemoveTickCallbackMethodInfo
    ResolveCompletionInfoMethod "renderIcon" o = Gtk.Widget.WidgetRenderIconMethodInfo
    ResolveCompletionInfoMethod "renderIconPixbuf" o = Gtk.Widget.WidgetRenderIconPixbufMethodInfo
    ResolveCompletionInfoMethod "reparent" o = Gtk.Widget.WidgetReparentMethodInfo
    ResolveCompletionInfoMethod "resetRcStyles" o = Gtk.Widget.WidgetResetRcStylesMethodInfo
    ResolveCompletionInfoMethod "resetStyle" o = Gtk.Widget.WidgetResetStyleMethodInfo
    ResolveCompletionInfoMethod "reshowWithInitialSize" o = Gtk.Window.WindowReshowWithInitialSizeMethodInfo
    ResolveCompletionInfoMethod "resize" o = Gtk.Window.WindowResizeMethodInfo
    ResolveCompletionInfoMethod "resizeChildren" o = Gtk.Container.ContainerResizeChildrenMethodInfo
    ResolveCompletionInfoMethod "resizeGripIsVisible" o = Gtk.Window.WindowResizeGripIsVisibleMethodInfo
    ResolveCompletionInfoMethod "resizeToGeometry" o = Gtk.Window.WindowResizeToGeometryMethodInfo
    ResolveCompletionInfoMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveCompletionInfoMethod "sendExpose" o = Gtk.Widget.WidgetSendExposeMethodInfo
    ResolveCompletionInfoMethod "sendFocusChange" o = Gtk.Widget.WidgetSendFocusChangeMethodInfo
    ResolveCompletionInfoMethod "shapeCombineRegion" o = Gtk.Widget.WidgetShapeCombineRegionMethodInfo
    ResolveCompletionInfoMethod "show" o = Gtk.Widget.WidgetShowMethodInfo
    ResolveCompletionInfoMethod "showAll" o = Gtk.Widget.WidgetShowAllMethodInfo
    ResolveCompletionInfoMethod "showNow" o = Gtk.Widget.WidgetShowNowMethodInfo
    ResolveCompletionInfoMethod "sizeAllocate" o = Gtk.Widget.WidgetSizeAllocateMethodInfo
    ResolveCompletionInfoMethod "sizeAllocateWithBaseline" o = Gtk.Widget.WidgetSizeAllocateWithBaselineMethodInfo
    ResolveCompletionInfoMethod "sizeRequest" o = Gtk.Widget.WidgetSizeRequestMethodInfo
    ResolveCompletionInfoMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveCompletionInfoMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveCompletionInfoMethod "stick" o = Gtk.Window.WindowStickMethodInfo
    ResolveCompletionInfoMethod "styleAttach" o = Gtk.Widget.WidgetStyleAttachMethodInfo
    ResolveCompletionInfoMethod "styleGetProperty" o = Gtk.Widget.WidgetStyleGetPropertyMethodInfo
    ResolveCompletionInfoMethod "thawChildNotify" o = Gtk.Widget.WidgetThawChildNotifyMethodInfo
    ResolveCompletionInfoMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveCompletionInfoMethod "translateCoordinates" o = Gtk.Widget.WidgetTranslateCoordinatesMethodInfo
    ResolveCompletionInfoMethod "triggerTooltipQuery" o = Gtk.Widget.WidgetTriggerTooltipQueryMethodInfo
    ResolveCompletionInfoMethod "unfullscreen" o = Gtk.Window.WindowUnfullscreenMethodInfo
    ResolveCompletionInfoMethod "unmap" o = Gtk.Widget.WidgetUnmapMethodInfo
    ResolveCompletionInfoMethod "unmaximize" o = Gtk.Window.WindowUnmaximizeMethodInfo
    ResolveCompletionInfoMethod "unparent" o = Gtk.Widget.WidgetUnparentMethodInfo
    ResolveCompletionInfoMethod "unrealize" o = Gtk.Widget.WidgetUnrealizeMethodInfo
    ResolveCompletionInfoMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveCompletionInfoMethod "unregisterWindow" o = Gtk.Widget.WidgetUnregisterWindowMethodInfo
    ResolveCompletionInfoMethod "unsetFocusChain" o = Gtk.Container.ContainerUnsetFocusChainMethodInfo
    ResolveCompletionInfoMethod "unsetStateFlags" o = Gtk.Widget.WidgetUnsetStateFlagsMethodInfo
    ResolveCompletionInfoMethod "unstick" o = Gtk.Window.WindowUnstickMethodInfo
    ResolveCompletionInfoMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveCompletionInfoMethod "getAcceptFocus" o = Gtk.Window.WindowGetAcceptFocusMethodInfo
    ResolveCompletionInfoMethod "getAccessible" o = Gtk.Widget.WidgetGetAccessibleMethodInfo
    ResolveCompletionInfoMethod "getActionGroup" o = Gtk.Widget.WidgetGetActionGroupMethodInfo
    ResolveCompletionInfoMethod "getAllocatedBaseline" o = Gtk.Widget.WidgetGetAllocatedBaselineMethodInfo
    ResolveCompletionInfoMethod "getAllocatedHeight" o = Gtk.Widget.WidgetGetAllocatedHeightMethodInfo
    ResolveCompletionInfoMethod "getAllocatedSize" o = Gtk.Widget.WidgetGetAllocatedSizeMethodInfo
    ResolveCompletionInfoMethod "getAllocatedWidth" o = Gtk.Widget.WidgetGetAllocatedWidthMethodInfo
    ResolveCompletionInfoMethod "getAllocation" o = Gtk.Widget.WidgetGetAllocationMethodInfo
    ResolveCompletionInfoMethod "getAncestor" o = Gtk.Widget.WidgetGetAncestorMethodInfo
    ResolveCompletionInfoMethod "getAppPaintable" o = Gtk.Widget.WidgetGetAppPaintableMethodInfo
    ResolveCompletionInfoMethod "getApplication" o = Gtk.Window.WindowGetApplicationMethodInfo
    ResolveCompletionInfoMethod "getAttachedTo" o = Gtk.Window.WindowGetAttachedToMethodInfo
    ResolveCompletionInfoMethod "getBorderWidth" o = Gtk.Container.ContainerGetBorderWidthMethodInfo
    ResolveCompletionInfoMethod "getCanDefault" o = Gtk.Widget.WidgetGetCanDefaultMethodInfo
    ResolveCompletionInfoMethod "getCanFocus" o = Gtk.Widget.WidgetGetCanFocusMethodInfo
    ResolveCompletionInfoMethod "getChild" o = Gtk.Bin.BinGetChildMethodInfo
    ResolveCompletionInfoMethod "getChildRequisition" o = Gtk.Widget.WidgetGetChildRequisitionMethodInfo
    ResolveCompletionInfoMethod "getChildVisible" o = Gtk.Widget.WidgetGetChildVisibleMethodInfo
    ResolveCompletionInfoMethod "getChildren" o = Gtk.Container.ContainerGetChildrenMethodInfo
    ResolveCompletionInfoMethod "getClip" o = Gtk.Widget.WidgetGetClipMethodInfo
    ResolveCompletionInfoMethod "getClipboard" o = Gtk.Widget.WidgetGetClipboardMethodInfo
    ResolveCompletionInfoMethod "getCompositeName" o = Gtk.Widget.WidgetGetCompositeNameMethodInfo
    ResolveCompletionInfoMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveCompletionInfoMethod "getDecorated" o = Gtk.Window.WindowGetDecoratedMethodInfo
    ResolveCompletionInfoMethod "getDefaultSize" o = Gtk.Window.WindowGetDefaultSizeMethodInfo
    ResolveCompletionInfoMethod "getDefaultWidget" o = Gtk.Window.WindowGetDefaultWidgetMethodInfo
    ResolveCompletionInfoMethod "getDeletable" o = Gtk.Window.WindowGetDeletableMethodInfo
    ResolveCompletionInfoMethod "getDestroyWithParent" o = Gtk.Window.WindowGetDestroyWithParentMethodInfo
    ResolveCompletionInfoMethod "getDeviceEnabled" o = Gtk.Widget.WidgetGetDeviceEnabledMethodInfo
    ResolveCompletionInfoMethod "getDeviceEvents" o = Gtk.Widget.WidgetGetDeviceEventsMethodInfo
    ResolveCompletionInfoMethod "getDirection" o = Gtk.Widget.WidgetGetDirectionMethodInfo
    ResolveCompletionInfoMethod "getDisplay" o = Gtk.Widget.WidgetGetDisplayMethodInfo
    ResolveCompletionInfoMethod "getDoubleBuffered" o = Gtk.Widget.WidgetGetDoubleBufferedMethodInfo
    ResolveCompletionInfoMethod "getEvents" o = Gtk.Widget.WidgetGetEventsMethodInfo
    ResolveCompletionInfoMethod "getFocus" o = Gtk.Window.WindowGetFocusMethodInfo
    ResolveCompletionInfoMethod "getFocusChain" o = Gtk.Container.ContainerGetFocusChainMethodInfo
    ResolveCompletionInfoMethod "getFocusChild" o = Gtk.Container.ContainerGetFocusChildMethodInfo
    ResolveCompletionInfoMethod "getFocusHadjustment" o = Gtk.Container.ContainerGetFocusHadjustmentMethodInfo
    ResolveCompletionInfoMethod "getFocusOnClick" o = Gtk.Widget.WidgetGetFocusOnClickMethodInfo
    ResolveCompletionInfoMethod "getFocusOnMap" o = Gtk.Window.WindowGetFocusOnMapMethodInfo
    ResolveCompletionInfoMethod "getFocusVadjustment" o = Gtk.Container.ContainerGetFocusVadjustmentMethodInfo
    ResolveCompletionInfoMethod "getFocusVisible" o = Gtk.Window.WindowGetFocusVisibleMethodInfo
    ResolveCompletionInfoMethod "getFontMap" o = Gtk.Widget.WidgetGetFontMapMethodInfo
    ResolveCompletionInfoMethod "getFontOptions" o = Gtk.Widget.WidgetGetFontOptionsMethodInfo
    ResolveCompletionInfoMethod "getFrameClock" o = Gtk.Widget.WidgetGetFrameClockMethodInfo
    ResolveCompletionInfoMethod "getGravity" o = Gtk.Window.WindowGetGravityMethodInfo
    ResolveCompletionInfoMethod "getGroup" o = Gtk.Window.WindowGetGroupMethodInfo
    ResolveCompletionInfoMethod "getHalign" o = Gtk.Widget.WidgetGetHalignMethodInfo
    ResolveCompletionInfoMethod "getHasResizeGrip" o = Gtk.Window.WindowGetHasResizeGripMethodInfo
    ResolveCompletionInfoMethod "getHasTooltip" o = Gtk.Widget.WidgetGetHasTooltipMethodInfo
    ResolveCompletionInfoMethod "getHasWindow" o = Gtk.Widget.WidgetGetHasWindowMethodInfo
    ResolveCompletionInfoMethod "getHexpand" o = Gtk.Widget.WidgetGetHexpandMethodInfo
    ResolveCompletionInfoMethod "getHexpandSet" o = Gtk.Widget.WidgetGetHexpandSetMethodInfo
    ResolveCompletionInfoMethod "getHideTitlebarWhenMaximized" o = Gtk.Window.WindowGetHideTitlebarWhenMaximizedMethodInfo
    ResolveCompletionInfoMethod "getIcon" o = Gtk.Window.WindowGetIconMethodInfo
    ResolveCompletionInfoMethod "getIconList" o = Gtk.Window.WindowGetIconListMethodInfo
    ResolveCompletionInfoMethod "getIconName" o = Gtk.Window.WindowGetIconNameMethodInfo
    ResolveCompletionInfoMethod "getInternalChild" o = Gtk.Buildable.BuildableGetInternalChildMethodInfo
    ResolveCompletionInfoMethod "getMapped" o = Gtk.Widget.WidgetGetMappedMethodInfo
    ResolveCompletionInfoMethod "getMarginBottom" o = Gtk.Widget.WidgetGetMarginBottomMethodInfo
    ResolveCompletionInfoMethod "getMarginEnd" o = Gtk.Widget.WidgetGetMarginEndMethodInfo
    ResolveCompletionInfoMethod "getMarginLeft" o = Gtk.Widget.WidgetGetMarginLeftMethodInfo
    ResolveCompletionInfoMethod "getMarginRight" o = Gtk.Widget.WidgetGetMarginRightMethodInfo
    ResolveCompletionInfoMethod "getMarginStart" o = Gtk.Widget.WidgetGetMarginStartMethodInfo
    ResolveCompletionInfoMethod "getMarginTop" o = Gtk.Widget.WidgetGetMarginTopMethodInfo
    ResolveCompletionInfoMethod "getMnemonicModifier" o = Gtk.Window.WindowGetMnemonicModifierMethodInfo
    ResolveCompletionInfoMethod "getMnemonicsVisible" o = Gtk.Window.WindowGetMnemonicsVisibleMethodInfo
    ResolveCompletionInfoMethod "getModal" o = Gtk.Window.WindowGetModalMethodInfo
    ResolveCompletionInfoMethod "getModifierMask" o = Gtk.Widget.WidgetGetModifierMaskMethodInfo
    ResolveCompletionInfoMethod "getModifierStyle" o = Gtk.Widget.WidgetGetModifierStyleMethodInfo
    ResolveCompletionInfoMethod "getName" o = Gtk.Widget.WidgetGetNameMethodInfo
    ResolveCompletionInfoMethod "getNoShowAll" o = Gtk.Widget.WidgetGetNoShowAllMethodInfo
    ResolveCompletionInfoMethod "getOpacity" o = Gtk.Window.WindowGetOpacityMethodInfo
    ResolveCompletionInfoMethod "getPangoContext" o = Gtk.Widget.WidgetGetPangoContextMethodInfo
    ResolveCompletionInfoMethod "getParent" o = Gtk.Widget.WidgetGetParentMethodInfo
    ResolveCompletionInfoMethod "getParentWindow" o = Gtk.Widget.WidgetGetParentWindowMethodInfo
    ResolveCompletionInfoMethod "getPath" o = Gtk.Widget.WidgetGetPathMethodInfo
    ResolveCompletionInfoMethod "getPathForChild" o = Gtk.Container.ContainerGetPathForChildMethodInfo
    ResolveCompletionInfoMethod "getPointer" o = Gtk.Widget.WidgetGetPointerMethodInfo
    ResolveCompletionInfoMethod "getPosition" o = Gtk.Window.WindowGetPositionMethodInfo
    ResolveCompletionInfoMethod "getPreferredHeight" o = Gtk.Widget.WidgetGetPreferredHeightMethodInfo
    ResolveCompletionInfoMethod "getPreferredHeightAndBaselineForWidth" o = Gtk.Widget.WidgetGetPreferredHeightAndBaselineForWidthMethodInfo
    ResolveCompletionInfoMethod "getPreferredHeightForWidth" o = Gtk.Widget.WidgetGetPreferredHeightForWidthMethodInfo
    ResolveCompletionInfoMethod "getPreferredSize" o = Gtk.Widget.WidgetGetPreferredSizeMethodInfo
    ResolveCompletionInfoMethod "getPreferredWidth" o = Gtk.Widget.WidgetGetPreferredWidthMethodInfo
    ResolveCompletionInfoMethod "getPreferredWidthForHeight" o = Gtk.Widget.WidgetGetPreferredWidthForHeightMethodInfo
    ResolveCompletionInfoMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveCompletionInfoMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveCompletionInfoMethod "getRealized" o = Gtk.Widget.WidgetGetRealizedMethodInfo
    ResolveCompletionInfoMethod "getReceivesDefault" o = Gtk.Widget.WidgetGetReceivesDefaultMethodInfo
    ResolveCompletionInfoMethod "getRequestMode" o = Gtk.Widget.WidgetGetRequestModeMethodInfo
    ResolveCompletionInfoMethod "getRequisition" o = Gtk.Widget.WidgetGetRequisitionMethodInfo
    ResolveCompletionInfoMethod "getResizable" o = Gtk.Window.WindowGetResizableMethodInfo
    ResolveCompletionInfoMethod "getResizeGripArea" o = Gtk.Window.WindowGetResizeGripAreaMethodInfo
    ResolveCompletionInfoMethod "getResizeMode" o = Gtk.Container.ContainerGetResizeModeMethodInfo
    ResolveCompletionInfoMethod "getRole" o = Gtk.Window.WindowGetRoleMethodInfo
    ResolveCompletionInfoMethod "getRootWindow" o = Gtk.Widget.WidgetGetRootWindowMethodInfo
    ResolveCompletionInfoMethod "getScaleFactor" o = Gtk.Widget.WidgetGetScaleFactorMethodInfo
    ResolveCompletionInfoMethod "getScreen" o = Gtk.Window.WindowGetScreenMethodInfo
    ResolveCompletionInfoMethod "getSensitive" o = Gtk.Widget.WidgetGetSensitiveMethodInfo
    ResolveCompletionInfoMethod "getSettings" o = Gtk.Widget.WidgetGetSettingsMethodInfo
    ResolveCompletionInfoMethod "getSize" o = Gtk.Window.WindowGetSizeMethodInfo
    ResolveCompletionInfoMethod "getSizeRequest" o = Gtk.Widget.WidgetGetSizeRequestMethodInfo
    ResolveCompletionInfoMethod "getSkipPagerHint" o = Gtk.Window.WindowGetSkipPagerHintMethodInfo
    ResolveCompletionInfoMethod "getSkipTaskbarHint" o = Gtk.Window.WindowGetSkipTaskbarHintMethodInfo
    ResolveCompletionInfoMethod "getState" o = Gtk.Widget.WidgetGetStateMethodInfo
    ResolveCompletionInfoMethod "getStateFlags" o = Gtk.Widget.WidgetGetStateFlagsMethodInfo
    ResolveCompletionInfoMethod "getStyle" o = Gtk.Widget.WidgetGetStyleMethodInfo
    ResolveCompletionInfoMethod "getStyleContext" o = Gtk.Widget.WidgetGetStyleContextMethodInfo
    ResolveCompletionInfoMethod "getSupportMultidevice" o = Gtk.Widget.WidgetGetSupportMultideviceMethodInfo
    ResolveCompletionInfoMethod "getTemplateChild" o = Gtk.Widget.WidgetGetTemplateChildMethodInfo
    ResolveCompletionInfoMethod "getTitle" o = Gtk.Window.WindowGetTitleMethodInfo
    ResolveCompletionInfoMethod "getTitlebar" o = Gtk.Window.WindowGetTitlebarMethodInfo
    ResolveCompletionInfoMethod "getTooltipMarkup" o = Gtk.Widget.WidgetGetTooltipMarkupMethodInfo
    ResolveCompletionInfoMethod "getTooltipText" o = Gtk.Widget.WidgetGetTooltipTextMethodInfo
    ResolveCompletionInfoMethod "getTooltipWindow" o = Gtk.Widget.WidgetGetTooltipWindowMethodInfo
    ResolveCompletionInfoMethod "getToplevel" o = Gtk.Widget.WidgetGetToplevelMethodInfo
    ResolveCompletionInfoMethod "getTransientFor" o = Gtk.Window.WindowGetTransientForMethodInfo
    ResolveCompletionInfoMethod "getTypeHint" o = Gtk.Window.WindowGetTypeHintMethodInfo
    ResolveCompletionInfoMethod "getUrgencyHint" o = Gtk.Window.WindowGetUrgencyHintMethodInfo
    ResolveCompletionInfoMethod "getValign" o = Gtk.Widget.WidgetGetValignMethodInfo
    ResolveCompletionInfoMethod "getValignWithBaseline" o = Gtk.Widget.WidgetGetValignWithBaselineMethodInfo
    ResolveCompletionInfoMethod "getVexpand" o = Gtk.Widget.WidgetGetVexpandMethodInfo
    ResolveCompletionInfoMethod "getVexpandSet" o = Gtk.Widget.WidgetGetVexpandSetMethodInfo
    ResolveCompletionInfoMethod "getVisible" o = Gtk.Widget.WidgetGetVisibleMethodInfo
    ResolveCompletionInfoMethod "getVisual" o = Gtk.Widget.WidgetGetVisualMethodInfo
    ResolveCompletionInfoMethod "getWidget" o = CompletionInfoGetWidgetMethodInfo
    ResolveCompletionInfoMethod "getWindow" o = Gtk.Widget.WidgetGetWindowMethodInfo
    ResolveCompletionInfoMethod "getWindowType" o = Gtk.Window.WindowGetWindowTypeMethodInfo
    ResolveCompletionInfoMethod "setAccelPath" o = Gtk.Widget.WidgetSetAccelPathMethodInfo
    ResolveCompletionInfoMethod "setAcceptFocus" o = Gtk.Window.WindowSetAcceptFocusMethodInfo
    ResolveCompletionInfoMethod "setAllocation" o = Gtk.Widget.WidgetSetAllocationMethodInfo
    ResolveCompletionInfoMethod "setAppPaintable" o = Gtk.Widget.WidgetSetAppPaintableMethodInfo
    ResolveCompletionInfoMethod "setApplication" o = Gtk.Window.WindowSetApplicationMethodInfo
    ResolveCompletionInfoMethod "setAttachedTo" o = Gtk.Window.WindowSetAttachedToMethodInfo
    ResolveCompletionInfoMethod "setBorderWidth" o = Gtk.Container.ContainerSetBorderWidthMethodInfo
    ResolveCompletionInfoMethod "setBuildableProperty" o = Gtk.Buildable.BuildableSetBuildablePropertyMethodInfo
    ResolveCompletionInfoMethod "setCanDefault" o = Gtk.Widget.WidgetSetCanDefaultMethodInfo
    ResolveCompletionInfoMethod "setCanFocus" o = Gtk.Widget.WidgetSetCanFocusMethodInfo
    ResolveCompletionInfoMethod "setChildVisible" o = Gtk.Widget.WidgetSetChildVisibleMethodInfo
    ResolveCompletionInfoMethod "setClip" o = Gtk.Widget.WidgetSetClipMethodInfo
    ResolveCompletionInfoMethod "setCompositeName" o = Gtk.Widget.WidgetSetCompositeNameMethodInfo
    ResolveCompletionInfoMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveCompletionInfoMethod "setDecorated" o = Gtk.Window.WindowSetDecoratedMethodInfo
    ResolveCompletionInfoMethod "setDefault" o = Gtk.Window.WindowSetDefaultMethodInfo
    ResolveCompletionInfoMethod "setDefaultGeometry" o = Gtk.Window.WindowSetDefaultGeometryMethodInfo
    ResolveCompletionInfoMethod "setDefaultSize" o = Gtk.Window.WindowSetDefaultSizeMethodInfo
    ResolveCompletionInfoMethod "setDeletable" o = Gtk.Window.WindowSetDeletableMethodInfo
    ResolveCompletionInfoMethod "setDestroyWithParent" o = Gtk.Window.WindowSetDestroyWithParentMethodInfo
    ResolveCompletionInfoMethod "setDeviceEnabled" o = Gtk.Widget.WidgetSetDeviceEnabledMethodInfo
    ResolveCompletionInfoMethod "setDeviceEvents" o = Gtk.Widget.WidgetSetDeviceEventsMethodInfo
    ResolveCompletionInfoMethod "setDirection" o = Gtk.Widget.WidgetSetDirectionMethodInfo
    ResolveCompletionInfoMethod "setDoubleBuffered" o = Gtk.Widget.WidgetSetDoubleBufferedMethodInfo
    ResolveCompletionInfoMethod "setEvents" o = Gtk.Widget.WidgetSetEventsMethodInfo
    ResolveCompletionInfoMethod "setFocus" o = Gtk.Window.WindowSetFocusMethodInfo
    ResolveCompletionInfoMethod "setFocusChain" o = Gtk.Container.ContainerSetFocusChainMethodInfo
    ResolveCompletionInfoMethod "setFocusChild" o = Gtk.Container.ContainerSetFocusChildMethodInfo
    ResolveCompletionInfoMethod "setFocusHadjustment" o = Gtk.Container.ContainerSetFocusHadjustmentMethodInfo
    ResolveCompletionInfoMethod "setFocusOnClick" o = Gtk.Widget.WidgetSetFocusOnClickMethodInfo
    ResolveCompletionInfoMethod "setFocusOnMap" o = Gtk.Window.WindowSetFocusOnMapMethodInfo
    ResolveCompletionInfoMethod "setFocusVadjustment" o = Gtk.Container.ContainerSetFocusVadjustmentMethodInfo
    ResolveCompletionInfoMethod "setFocusVisible" o = Gtk.Window.WindowSetFocusVisibleMethodInfo
    ResolveCompletionInfoMethod "setFontMap" o = Gtk.Widget.WidgetSetFontMapMethodInfo
    ResolveCompletionInfoMethod "setFontOptions" o = Gtk.Widget.WidgetSetFontOptionsMethodInfo
    ResolveCompletionInfoMethod "setGeometryHints" o = Gtk.Window.WindowSetGeometryHintsMethodInfo
    ResolveCompletionInfoMethod "setGravity" o = Gtk.Window.WindowSetGravityMethodInfo
    ResolveCompletionInfoMethod "setHalign" o = Gtk.Widget.WidgetSetHalignMethodInfo
    ResolveCompletionInfoMethod "setHasResizeGrip" o = Gtk.Window.WindowSetHasResizeGripMethodInfo
    ResolveCompletionInfoMethod "setHasTooltip" o = Gtk.Widget.WidgetSetHasTooltipMethodInfo
    ResolveCompletionInfoMethod "setHasUserRefCount" o = Gtk.Window.WindowSetHasUserRefCountMethodInfo
    ResolveCompletionInfoMethod "setHasWindow" o = Gtk.Widget.WidgetSetHasWindowMethodInfo
    ResolveCompletionInfoMethod "setHexpand" o = Gtk.Widget.WidgetSetHexpandMethodInfo
    ResolveCompletionInfoMethod "setHexpandSet" o = Gtk.Widget.WidgetSetHexpandSetMethodInfo
    ResolveCompletionInfoMethod "setHideTitlebarWhenMaximized" o = Gtk.Window.WindowSetHideTitlebarWhenMaximizedMethodInfo
    ResolveCompletionInfoMethod "setIcon" o = Gtk.Window.WindowSetIconMethodInfo
    ResolveCompletionInfoMethod "setIconFromFile" o = Gtk.Window.WindowSetIconFromFileMethodInfo
    ResolveCompletionInfoMethod "setIconList" o = Gtk.Window.WindowSetIconListMethodInfo
    ResolveCompletionInfoMethod "setIconName" o = Gtk.Window.WindowSetIconNameMethodInfo
    ResolveCompletionInfoMethod "setKeepAbove" o = Gtk.Window.WindowSetKeepAboveMethodInfo
    ResolveCompletionInfoMethod "setKeepBelow" o = Gtk.Window.WindowSetKeepBelowMethodInfo
    ResolveCompletionInfoMethod "setMapped" o = Gtk.Widget.WidgetSetMappedMethodInfo
    ResolveCompletionInfoMethod "setMarginBottom" o = Gtk.Widget.WidgetSetMarginBottomMethodInfo
    ResolveCompletionInfoMethod "setMarginEnd" o = Gtk.Widget.WidgetSetMarginEndMethodInfo
    ResolveCompletionInfoMethod "setMarginLeft" o = Gtk.Widget.WidgetSetMarginLeftMethodInfo
    ResolveCompletionInfoMethod "setMarginRight" o = Gtk.Widget.WidgetSetMarginRightMethodInfo
    ResolveCompletionInfoMethod "setMarginStart" o = Gtk.Widget.WidgetSetMarginStartMethodInfo
    ResolveCompletionInfoMethod "setMarginTop" o = Gtk.Widget.WidgetSetMarginTopMethodInfo
    ResolveCompletionInfoMethod "setMnemonicModifier" o = Gtk.Window.WindowSetMnemonicModifierMethodInfo
    ResolveCompletionInfoMethod "setMnemonicsVisible" o = Gtk.Window.WindowSetMnemonicsVisibleMethodInfo
    ResolveCompletionInfoMethod "setModal" o = Gtk.Window.WindowSetModalMethodInfo
    ResolveCompletionInfoMethod "setName" o = Gtk.Widget.WidgetSetNameMethodInfo
    ResolveCompletionInfoMethod "setNoShowAll" o = Gtk.Widget.WidgetSetNoShowAllMethodInfo
    ResolveCompletionInfoMethod "setOpacity" o = Gtk.Window.WindowSetOpacityMethodInfo
    ResolveCompletionInfoMethod "setParent" o = Gtk.Widget.WidgetSetParentMethodInfo
    ResolveCompletionInfoMethod "setParentWindow" o = Gtk.Widget.WidgetSetParentWindowMethodInfo
    ResolveCompletionInfoMethod "setPosition" o = Gtk.Window.WindowSetPositionMethodInfo
    ResolveCompletionInfoMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveCompletionInfoMethod "setRealized" o = Gtk.Widget.WidgetSetRealizedMethodInfo
    ResolveCompletionInfoMethod "setReallocateRedraws" o = Gtk.Container.ContainerSetReallocateRedrawsMethodInfo
    ResolveCompletionInfoMethod "setReceivesDefault" o = Gtk.Widget.WidgetSetReceivesDefaultMethodInfo
    ResolveCompletionInfoMethod "setRedrawOnAllocate" o = Gtk.Widget.WidgetSetRedrawOnAllocateMethodInfo
    ResolveCompletionInfoMethod "setResizable" o = Gtk.Window.WindowSetResizableMethodInfo
    ResolveCompletionInfoMethod "setResizeMode" o = Gtk.Container.ContainerSetResizeModeMethodInfo
    ResolveCompletionInfoMethod "setRole" o = Gtk.Window.WindowSetRoleMethodInfo
    ResolveCompletionInfoMethod "setScreen" o = Gtk.Window.WindowSetScreenMethodInfo
    ResolveCompletionInfoMethod "setSensitive" o = Gtk.Widget.WidgetSetSensitiveMethodInfo
    ResolveCompletionInfoMethod "setSizeRequest" o = Gtk.Widget.WidgetSetSizeRequestMethodInfo
    ResolveCompletionInfoMethod "setSkipPagerHint" o = Gtk.Window.WindowSetSkipPagerHintMethodInfo
    ResolveCompletionInfoMethod "setSkipTaskbarHint" o = Gtk.Window.WindowSetSkipTaskbarHintMethodInfo
    ResolveCompletionInfoMethod "setStartupId" o = Gtk.Window.WindowSetStartupIdMethodInfo
    ResolveCompletionInfoMethod "setState" o = Gtk.Widget.WidgetSetStateMethodInfo
    ResolveCompletionInfoMethod "setStateFlags" o = Gtk.Widget.WidgetSetStateFlagsMethodInfo
    ResolveCompletionInfoMethod "setStyle" o = Gtk.Widget.WidgetSetStyleMethodInfo
    ResolveCompletionInfoMethod "setSupportMultidevice" o = Gtk.Widget.WidgetSetSupportMultideviceMethodInfo
    ResolveCompletionInfoMethod "setTitle" o = Gtk.Window.WindowSetTitleMethodInfo
    ResolveCompletionInfoMethod "setTitlebar" o = Gtk.Window.WindowSetTitlebarMethodInfo
    ResolveCompletionInfoMethod "setTooltipMarkup" o = Gtk.Widget.WidgetSetTooltipMarkupMethodInfo
    ResolveCompletionInfoMethod "setTooltipText" o = Gtk.Widget.WidgetSetTooltipTextMethodInfo
    ResolveCompletionInfoMethod "setTooltipWindow" o = Gtk.Widget.WidgetSetTooltipWindowMethodInfo
    ResolveCompletionInfoMethod "setTransientFor" o = Gtk.Window.WindowSetTransientForMethodInfo
    ResolveCompletionInfoMethod "setTypeHint" o = Gtk.Window.WindowSetTypeHintMethodInfo
    ResolveCompletionInfoMethod "setUrgencyHint" o = Gtk.Window.WindowSetUrgencyHintMethodInfo
    ResolveCompletionInfoMethod "setValign" o = Gtk.Widget.WidgetSetValignMethodInfo
    ResolveCompletionInfoMethod "setVexpand" o = Gtk.Widget.WidgetSetVexpandMethodInfo
    ResolveCompletionInfoMethod "setVexpandSet" o = Gtk.Widget.WidgetSetVexpandSetMethodInfo
    ResolveCompletionInfoMethod "setVisible" o = Gtk.Widget.WidgetSetVisibleMethodInfo
    ResolveCompletionInfoMethod "setVisual" o = Gtk.Widget.WidgetSetVisualMethodInfo
    ResolveCompletionInfoMethod "setWidget" o = CompletionInfoSetWidgetMethodInfo
    ResolveCompletionInfoMethod "setWindow" o = Gtk.Widget.WidgetSetWindowMethodInfo
    ResolveCompletionInfoMethod "setWmclass" o = Gtk.Window.WindowSetWmclassMethodInfo
    ResolveCompletionInfoMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveCompletionInfoMethod t CompletionInfo, O.MethodInfo info CompletionInfo p) => OL.IsLabel t (CompletionInfo -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

-- signal CompletionInfo::before-show
{-# DEPRECATED CompletionInfoBeforeShowCallback ["(Since version 3.10)","This signal should not be used."] #-}
{- |
This signal is emitted before any \"show\" management. You can connect
to this signal if you want to change some properties or position
before the real \"show\".
-}
type CompletionInfoBeforeShowCallback =
    IO ()

-- | A convenience synonym for @`Nothing` :: `Maybe` `CompletionInfoBeforeShowCallback`@.
noCompletionInfoBeforeShowCallback :: Maybe CompletionInfoBeforeShowCallback
noCompletionInfoBeforeShowCallback = Nothing

-- | Type for the callback on the (unwrapped) C side.
type C_CompletionInfoBeforeShowCallback =
    Ptr () ->                               -- object
    Ptr () ->                               -- user_data
    IO ()

-- | Generate a function pointer callable from C code, from a `C_CompletionInfoBeforeShowCallback`.
foreign import ccall "wrapper"
    mk_CompletionInfoBeforeShowCallback :: C_CompletionInfoBeforeShowCallback -> IO (FunPtr C_CompletionInfoBeforeShowCallback)

-- | Wrap the callback into a `GClosure`.
genClosure_CompletionInfoBeforeShow :: MonadIO m => CompletionInfoBeforeShowCallback -> m (GClosure C_CompletionInfoBeforeShowCallback)
genClosure_CompletionInfoBeforeShow cb = liftIO $ do
    let cb' = wrap_CompletionInfoBeforeShowCallback cb
    mk_CompletionInfoBeforeShowCallback cb' >>= B.GClosure.newGClosure


-- | Wrap a `CompletionInfoBeforeShowCallback` into a `C_CompletionInfoBeforeShowCallback`.
wrap_CompletionInfoBeforeShowCallback ::
    CompletionInfoBeforeShowCallback ->
    C_CompletionInfoBeforeShowCallback
wrap_CompletionInfoBeforeShowCallback _cb _ _ = do
    _cb 


{- |
Connect a signal handler for the “@before-show@” signal, to be run before the default handler.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Signals.on' completionInfo #beforeShow callback
@
-}
onCompletionInfoBeforeShow :: (IsCompletionInfo a, MonadIO m) => a -> CompletionInfoBeforeShowCallback -> m SignalHandlerId
onCompletionInfoBeforeShow obj cb = liftIO $ do
    let cb' = wrap_CompletionInfoBeforeShowCallback cb
    cb'' <- mk_CompletionInfoBeforeShowCallback cb'
    connectSignalFunPtr obj "before-show" cb'' SignalConnectBefore

{- |
Connect a signal handler for the “@before-show@” signal, to be run after the default handler.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Signals.after' completionInfo #beforeShow callback
@
-}
afterCompletionInfoBeforeShow :: (IsCompletionInfo a, MonadIO m) => a -> CompletionInfoBeforeShowCallback -> m SignalHandlerId
afterCompletionInfoBeforeShow obj cb = liftIO $ do
    let cb' = wrap_CompletionInfoBeforeShowCallback cb
    cb'' <- mk_CompletionInfoBeforeShowCallback cb'
    connectSignalFunPtr obj "before-show" cb'' SignalConnectAfter


#if ENABLE_OVERLOADING
instance O.HasAttributeList CompletionInfo
type instance O.AttributeList CompletionInfo = CompletionInfoAttributeList
type CompletionInfoAttributeList = ('[ '("acceptFocus", Gtk.Window.WindowAcceptFocusPropertyInfo), '("appPaintable", Gtk.Widget.WidgetAppPaintablePropertyInfo), '("application", Gtk.Window.WindowApplicationPropertyInfo), '("attachedTo", Gtk.Window.WindowAttachedToPropertyInfo), '("borderWidth", Gtk.Container.ContainerBorderWidthPropertyInfo), '("canDefault", Gtk.Widget.WidgetCanDefaultPropertyInfo), '("canFocus", Gtk.Widget.WidgetCanFocusPropertyInfo), '("child", Gtk.Container.ContainerChildPropertyInfo), '("compositeChild", Gtk.Widget.WidgetCompositeChildPropertyInfo), '("decorated", Gtk.Window.WindowDecoratedPropertyInfo), '("defaultHeight", Gtk.Window.WindowDefaultHeightPropertyInfo), '("defaultWidth", Gtk.Window.WindowDefaultWidthPropertyInfo), '("deletable", Gtk.Window.WindowDeletablePropertyInfo), '("destroyWithParent", Gtk.Window.WindowDestroyWithParentPropertyInfo), '("doubleBuffered", Gtk.Widget.WidgetDoubleBufferedPropertyInfo), '("events", Gtk.Widget.WidgetEventsPropertyInfo), '("expand", Gtk.Widget.WidgetExpandPropertyInfo), '("focusOnClick", Gtk.Widget.WidgetFocusOnClickPropertyInfo), '("focusOnMap", Gtk.Window.WindowFocusOnMapPropertyInfo), '("focusVisible", Gtk.Window.WindowFocusVisiblePropertyInfo), '("gravity", Gtk.Window.WindowGravityPropertyInfo), '("halign", Gtk.Widget.WidgetHalignPropertyInfo), '("hasDefault", Gtk.Widget.WidgetHasDefaultPropertyInfo), '("hasFocus", Gtk.Widget.WidgetHasFocusPropertyInfo), '("hasResizeGrip", Gtk.Window.WindowHasResizeGripPropertyInfo), '("hasTooltip", Gtk.Widget.WidgetHasTooltipPropertyInfo), '("hasToplevelFocus", Gtk.Window.WindowHasToplevelFocusPropertyInfo), '("heightRequest", Gtk.Widget.WidgetHeightRequestPropertyInfo), '("hexpand", Gtk.Widget.WidgetHexpandPropertyInfo), '("hexpandSet", Gtk.Widget.WidgetHexpandSetPropertyInfo), '("hideTitlebarWhenMaximized", Gtk.Window.WindowHideTitlebarWhenMaximizedPropertyInfo), '("icon", Gtk.Window.WindowIconPropertyInfo), '("iconName", Gtk.Window.WindowIconNamePropertyInfo), '("isActive", Gtk.Window.WindowIsActivePropertyInfo), '("isFocus", Gtk.Widget.WidgetIsFocusPropertyInfo), '("isMaximized", Gtk.Window.WindowIsMaximizedPropertyInfo), '("margin", Gtk.Widget.WidgetMarginPropertyInfo), '("marginBottom", Gtk.Widget.WidgetMarginBottomPropertyInfo), '("marginEnd", Gtk.Widget.WidgetMarginEndPropertyInfo), '("marginLeft", Gtk.Widget.WidgetMarginLeftPropertyInfo), '("marginRight", Gtk.Widget.WidgetMarginRightPropertyInfo), '("marginStart", Gtk.Widget.WidgetMarginStartPropertyInfo), '("marginTop", Gtk.Widget.WidgetMarginTopPropertyInfo), '("mnemonicsVisible", Gtk.Window.WindowMnemonicsVisiblePropertyInfo), '("modal", Gtk.Window.WindowModalPropertyInfo), '("name", Gtk.Widget.WidgetNamePropertyInfo), '("noShowAll", Gtk.Widget.WidgetNoShowAllPropertyInfo), '("opacity", Gtk.Widget.WidgetOpacityPropertyInfo), '("parent", Gtk.Widget.WidgetParentPropertyInfo), '("receivesDefault", Gtk.Widget.WidgetReceivesDefaultPropertyInfo), '("resizable", Gtk.Window.WindowResizablePropertyInfo), '("resizeGripVisible", Gtk.Window.WindowResizeGripVisiblePropertyInfo), '("resizeMode", Gtk.Container.ContainerResizeModePropertyInfo), '("role", Gtk.Window.WindowRolePropertyInfo), '("scaleFactor", Gtk.Widget.WidgetScaleFactorPropertyInfo), '("screen", Gtk.Window.WindowScreenPropertyInfo), '("sensitive", Gtk.Widget.WidgetSensitivePropertyInfo), '("skipPagerHint", Gtk.Window.WindowSkipPagerHintPropertyInfo), '("skipTaskbarHint", Gtk.Window.WindowSkipTaskbarHintPropertyInfo), '("startupId", Gtk.Window.WindowStartupIdPropertyInfo), '("style", Gtk.Widget.WidgetStylePropertyInfo), '("title", Gtk.Window.WindowTitlePropertyInfo), '("tooltipMarkup", Gtk.Widget.WidgetTooltipMarkupPropertyInfo), '("tooltipText", Gtk.Widget.WidgetTooltipTextPropertyInfo), '("transientFor", Gtk.Window.WindowTransientForPropertyInfo), '("type", Gtk.Window.WindowTypePropertyInfo), '("typeHint", Gtk.Window.WindowTypeHintPropertyInfo), '("urgencyHint", Gtk.Window.WindowUrgencyHintPropertyInfo), '("valign", Gtk.Widget.WidgetValignPropertyInfo), '("vexpand", Gtk.Widget.WidgetVexpandPropertyInfo), '("vexpandSet", Gtk.Widget.WidgetVexpandSetPropertyInfo), '("visible", Gtk.Widget.WidgetVisiblePropertyInfo), '("widthRequest", Gtk.Widget.WidgetWidthRequestPropertyInfo), '("window", Gtk.Widget.WidgetWindowPropertyInfo), '("windowPosition", Gtk.Window.WindowWindowPositionPropertyInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
#endif

#if ENABLE_OVERLOADING
data CompletionInfoBeforeShowSignalInfo
instance SignalInfo CompletionInfoBeforeShowSignalInfo where
    type HaskellCallbackType CompletionInfoBeforeShowSignalInfo = CompletionInfoBeforeShowCallback
    connectSignal _ obj cb connectMode = do
        let cb' = wrap_CompletionInfoBeforeShowCallback cb
        cb'' <- mk_CompletionInfoBeforeShowCallback cb'
        connectSignalFunPtr obj "before-show" cb'' connectMode

type instance O.SignalList CompletionInfo = CompletionInfoSignalList
type CompletionInfoSignalList = ('[ '("accelClosuresChanged", Gtk.Widget.WidgetAccelClosuresChangedSignalInfo), '("activateDefault", Gtk.Window.WindowActivateDefaultSignalInfo), '("activateFocus", Gtk.Window.WindowActivateFocusSignalInfo), '("add", Gtk.Container.ContainerAddSignalInfo), '("beforeShow", CompletionInfoBeforeShowSignalInfo), '("buttonPressEvent", Gtk.Widget.WidgetButtonPressEventSignalInfo), '("buttonReleaseEvent", Gtk.Widget.WidgetButtonReleaseEventSignalInfo), '("canActivateAccel", Gtk.Widget.WidgetCanActivateAccelSignalInfo), '("checkResize", Gtk.Container.ContainerCheckResizeSignalInfo), '("childNotify", Gtk.Widget.WidgetChildNotifySignalInfo), '("compositedChanged", Gtk.Widget.WidgetCompositedChangedSignalInfo), '("configureEvent", Gtk.Widget.WidgetConfigureEventSignalInfo), '("damageEvent", Gtk.Widget.WidgetDamageEventSignalInfo), '("deleteEvent", Gtk.Widget.WidgetDeleteEventSignalInfo), '("destroy", Gtk.Widget.WidgetDestroySignalInfo), '("destroyEvent", Gtk.Widget.WidgetDestroyEventSignalInfo), '("directionChanged", Gtk.Widget.WidgetDirectionChangedSignalInfo), '("dragBegin", Gtk.Widget.WidgetDragBeginSignalInfo), '("dragDataDelete", Gtk.Widget.WidgetDragDataDeleteSignalInfo), '("dragDataGet", Gtk.Widget.WidgetDragDataGetSignalInfo), '("dragDataReceived", Gtk.Widget.WidgetDragDataReceivedSignalInfo), '("dragDrop", Gtk.Widget.WidgetDragDropSignalInfo), '("dragEnd", Gtk.Widget.WidgetDragEndSignalInfo), '("dragFailed", Gtk.Widget.WidgetDragFailedSignalInfo), '("dragLeave", Gtk.Widget.WidgetDragLeaveSignalInfo), '("dragMotion", Gtk.Widget.WidgetDragMotionSignalInfo), '("draw", Gtk.Widget.WidgetDrawSignalInfo), '("enableDebugging", Gtk.Window.WindowEnableDebuggingSignalInfo), '("enterNotifyEvent", Gtk.Widget.WidgetEnterNotifyEventSignalInfo), '("event", Gtk.Widget.WidgetEventSignalInfo), '("eventAfter", Gtk.Widget.WidgetEventAfterSignalInfo), '("focus", Gtk.Widget.WidgetFocusSignalInfo), '("focusInEvent", Gtk.Widget.WidgetFocusInEventSignalInfo), '("focusOutEvent", Gtk.Widget.WidgetFocusOutEventSignalInfo), '("grabBrokenEvent", Gtk.Widget.WidgetGrabBrokenEventSignalInfo), '("grabFocus", Gtk.Widget.WidgetGrabFocusSignalInfo), '("grabNotify", Gtk.Widget.WidgetGrabNotifySignalInfo), '("hide", Gtk.Widget.WidgetHideSignalInfo), '("hierarchyChanged", Gtk.Widget.WidgetHierarchyChangedSignalInfo), '("keyPressEvent", Gtk.Widget.WidgetKeyPressEventSignalInfo), '("keyReleaseEvent", Gtk.Widget.WidgetKeyReleaseEventSignalInfo), '("keynavFailed", Gtk.Widget.WidgetKeynavFailedSignalInfo), '("keysChanged", Gtk.Window.WindowKeysChangedSignalInfo), '("leaveNotifyEvent", Gtk.Widget.WidgetLeaveNotifyEventSignalInfo), '("map", Gtk.Widget.WidgetMapSignalInfo), '("mapEvent", Gtk.Widget.WidgetMapEventSignalInfo), '("mnemonicActivate", Gtk.Widget.WidgetMnemonicActivateSignalInfo), '("motionNotifyEvent", Gtk.Widget.WidgetMotionNotifyEventSignalInfo), '("moveFocus", Gtk.Widget.WidgetMoveFocusSignalInfo), '("notify", GObject.Object.ObjectNotifySignalInfo), '("parentSet", Gtk.Widget.WidgetParentSetSignalInfo), '("popupMenu", Gtk.Widget.WidgetPopupMenuSignalInfo), '("propertyNotifyEvent", Gtk.Widget.WidgetPropertyNotifyEventSignalInfo), '("proximityInEvent", Gtk.Widget.WidgetProximityInEventSignalInfo), '("proximityOutEvent", Gtk.Widget.WidgetProximityOutEventSignalInfo), '("queryTooltip", Gtk.Widget.WidgetQueryTooltipSignalInfo), '("realize", Gtk.Widget.WidgetRealizeSignalInfo), '("remove", Gtk.Container.ContainerRemoveSignalInfo), '("screenChanged", Gtk.Widget.WidgetScreenChangedSignalInfo), '("scrollEvent", Gtk.Widget.WidgetScrollEventSignalInfo), '("selectionClearEvent", Gtk.Widget.WidgetSelectionClearEventSignalInfo), '("selectionGet", Gtk.Widget.WidgetSelectionGetSignalInfo), '("selectionNotifyEvent", Gtk.Widget.WidgetSelectionNotifyEventSignalInfo), '("selectionReceived", Gtk.Widget.WidgetSelectionReceivedSignalInfo), '("selectionRequestEvent", Gtk.Widget.WidgetSelectionRequestEventSignalInfo), '("setFocus", Gtk.Window.WindowSetFocusSignalInfo), '("setFocusChild", Gtk.Container.ContainerSetFocusChildSignalInfo), '("show", Gtk.Widget.WidgetShowSignalInfo), '("showHelp", Gtk.Widget.WidgetShowHelpSignalInfo), '("sizeAllocate", Gtk.Widget.WidgetSizeAllocateSignalInfo), '("stateChanged", Gtk.Widget.WidgetStateChangedSignalInfo), '("stateFlagsChanged", Gtk.Widget.WidgetStateFlagsChangedSignalInfo), '("styleSet", Gtk.Widget.WidgetStyleSetSignalInfo), '("styleUpdated", Gtk.Widget.WidgetStyleUpdatedSignalInfo), '("touchEvent", Gtk.Widget.WidgetTouchEventSignalInfo), '("unmap", Gtk.Widget.WidgetUnmapSignalInfo), '("unmapEvent", Gtk.Widget.WidgetUnmapEventSignalInfo), '("unrealize", Gtk.Widget.WidgetUnrealizeSignalInfo), '("visibilityNotifyEvent", Gtk.Widget.WidgetVisibilityNotifyEventSignalInfo), '("windowStateEvent", Gtk.Widget.WidgetWindowStateEventSignalInfo)] :: [(Symbol, *)])

#endif

-- method CompletionInfo::new
-- method type : Constructor
-- Args : []
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "GtkSource", name = "CompletionInfo"}))
-- throws : False
-- Skip return : False

foreign import ccall "gtk_source_completion_info_new" gtk_source_completion_info_new :: 
    IO (Ptr CompletionInfo)

{- |
/No description available in the introspection data./
-}
completionInfoNew ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    m CompletionInfo
    {- ^ __Returns:__ a new GtkSourceCompletionInfo. -}
completionInfoNew  = liftIO $ do
    result <- gtk_source_completion_info_new
    checkUnexpectedReturnNULL "completionInfoNew" result
    result' <- (newObject CompletionInfo) result
    return result'

#if ENABLE_OVERLOADING
#endif

-- method CompletionInfo::get_widget
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "info", argType = TInterface (Name {namespace = "GtkSource", name = "CompletionInfo"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GtkSourceCompletionInfo.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "Gtk", name = "Widget"}))
-- throws : False
-- Skip return : False

foreign import ccall "gtk_source_completion_info_get_widget" gtk_source_completion_info_get_widget :: 
    Ptr CompletionInfo ->                   -- info : TInterface (Name {namespace = "GtkSource", name = "CompletionInfo"})
    IO (Ptr Gtk.Widget.Widget)

{-# DEPRECATED completionInfoGetWidget ["(Since version 3.8)","Use 'GI.Gtk.Objects.Bin.binGetChild' instead."] #-}
{- |
Get the current content widget.
-}
completionInfoGetWidget ::
    (B.CallStack.HasCallStack, MonadIO m, IsCompletionInfo a) =>
    a
    {- ^ /@info@/: a 'GI.GtkSource.Objects.CompletionInfo.CompletionInfo'. -}
    -> m Gtk.Widget.Widget
    {- ^ __Returns:__ The current content widget. -}
completionInfoGetWidget info = liftIO $ do
    info' <- unsafeManagedPtrCastPtr info
    result <- gtk_source_completion_info_get_widget info'
    checkUnexpectedReturnNULL "completionInfoGetWidget" result
    result' <- (newObject Gtk.Widget.Widget) result
    touchManagedPtr info
    return result'

#if ENABLE_OVERLOADING
data CompletionInfoGetWidgetMethodInfo
instance (signature ~ (m Gtk.Widget.Widget), MonadIO m, IsCompletionInfo a) => O.MethodInfo CompletionInfoGetWidgetMethodInfo a signature where
    overloadedMethod _ = completionInfoGetWidget

#endif

-- method CompletionInfo::move_to_iter
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "info", argType = TInterface (Name {namespace = "GtkSource", name = "CompletionInfo"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GtkSourceCompletionInfo.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "view", argType = TInterface (Name {namespace = "Gtk", name = "TextView"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GtkTextView on which the info window should be positioned.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "iter", argType = TInterface (Name {namespace = "Gtk", name = "TextIter"}), direction = DirectionIn, mayBeNull = True, argDoc = Documentation {rawDocText = Just "a #GtkTextIter.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "gtk_source_completion_info_move_to_iter" gtk_source_completion_info_move_to_iter :: 
    Ptr CompletionInfo ->                   -- info : TInterface (Name {namespace = "GtkSource", name = "CompletionInfo"})
    Ptr Gtk.TextView.TextView ->            -- view : TInterface (Name {namespace = "Gtk", name = "TextView"})
    Ptr Gtk.TextIter.TextIter ->            -- iter : TInterface (Name {namespace = "Gtk", name = "TextIter"})
    IO ()

{- |
Moves the 'GI.GtkSource.Objects.CompletionInfo.CompletionInfo' to /@iter@/. If /@iter@/ is 'Nothing' /@info@/ is
moved to the cursor position. Moving will respect the 'GI.Gdk.Enums.Gravity' setting
of the info window and will ensure the line at /@iter@/ is not occluded by
the window.
-}
completionInfoMoveToIter ::
    (B.CallStack.HasCallStack, MonadIO m, IsCompletionInfo a, Gtk.TextView.IsTextView b) =>
    a
    {- ^ /@info@/: a 'GI.GtkSource.Objects.CompletionInfo.CompletionInfo'. -}
    -> b
    {- ^ /@view@/: a 'GI.Gtk.Objects.TextView.TextView' on which the info window should be positioned. -}
    -> Maybe (Gtk.TextIter.TextIter)
    {- ^ /@iter@/: a 'GI.Gtk.Structs.TextIter.TextIter'. -}
    -> m ()
completionInfoMoveToIter info view iter = liftIO $ do
    info' <- unsafeManagedPtrCastPtr info
    view' <- unsafeManagedPtrCastPtr view
    maybeIter <- case iter of
        Nothing -> return nullPtr
        Just jIter -> do
            jIter' <- unsafeManagedPtrGetPtr jIter
            return jIter'
    gtk_source_completion_info_move_to_iter info' view' maybeIter
    touchManagedPtr info
    touchManagedPtr view
    whenJust iter touchManagedPtr
    return ()

#if ENABLE_OVERLOADING
data CompletionInfoMoveToIterMethodInfo
instance (signature ~ (b -> Maybe (Gtk.TextIter.TextIter) -> m ()), MonadIO m, IsCompletionInfo a, Gtk.TextView.IsTextView b) => O.MethodInfo CompletionInfoMoveToIterMethodInfo a signature where
    overloadedMethod _ = completionInfoMoveToIter

#endif

-- method CompletionInfo::set_widget
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "info", argType = TInterface (Name {namespace = "GtkSource", name = "CompletionInfo"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GtkSourceCompletionInfo.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "widget", argType = TInterface (Name {namespace = "Gtk", name = "Widget"}), direction = DirectionIn, mayBeNull = True, argDoc = Documentation {rawDocText = Just "a #GtkWidget.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "gtk_source_completion_info_set_widget" gtk_source_completion_info_set_widget :: 
    Ptr CompletionInfo ->                   -- info : TInterface (Name {namespace = "GtkSource", name = "CompletionInfo"})
    Ptr Gtk.Widget.Widget ->                -- widget : TInterface (Name {namespace = "Gtk", name = "Widget"})
    IO ()

{-# DEPRECATED completionInfoSetWidget ["(Since version 3.8)","Use 'GI.Gtk.Objects.Container.containerAdd' instead. If there is already a child","widget, remove it with 'GI.Gtk.Objects.Container.containerRemove'."] #-}
{- |
Sets the content widget of the info window. See that the previous widget will
lose a reference and it can be destroyed, so if you do not want this to
happen you must use 'GI.GObject.Objects.Object.objectRef' before calling this method.
-}
completionInfoSetWidget ::
    (B.CallStack.HasCallStack, MonadIO m, IsCompletionInfo a, Gtk.Widget.IsWidget b) =>
    a
    {- ^ /@info@/: a 'GI.GtkSource.Objects.CompletionInfo.CompletionInfo'. -}
    -> Maybe (b)
    {- ^ /@widget@/: a 'GI.Gtk.Objects.Widget.Widget'. -}
    -> m ()
completionInfoSetWidget info widget = liftIO $ do
    info' <- unsafeManagedPtrCastPtr info
    maybeWidget <- case widget of
        Nothing -> return nullPtr
        Just jWidget -> do
            jWidget' <- unsafeManagedPtrCastPtr jWidget
            return jWidget'
    gtk_source_completion_info_set_widget info' maybeWidget
    touchManagedPtr info
    whenJust widget touchManagedPtr
    return ()

#if ENABLE_OVERLOADING
data CompletionInfoSetWidgetMethodInfo
instance (signature ~ (Maybe (b) -> m ()), MonadIO m, IsCompletionInfo a, Gtk.Widget.IsWidget b) => O.MethodInfo CompletionInfoSetWidgetMethodInfo a signature where
    overloadedMethod _ = completionInfoSetWidget

#endif


