

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.GtkSource.Objects.Map
    ( 

-- * Exported types
    Map(..)                                 ,
    IsMap                                   ,
    toMap                                   ,
    noMap                                   ,


 -- * Methods
-- ** getView #method:getView#

#if ENABLE_OVERLOADING
    MapGetViewMethodInfo                    ,
#endif
    mapGetView                              ,


-- ** new #method:new#

    mapNew                                  ,


-- ** setView #method:setView#

#if ENABLE_OVERLOADING
    MapSetViewMethodInfo                    ,
#endif
    mapSetView                              ,




 -- * Properties
-- ** fontDesc #attr:fontDesc#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    MapFontDescPropertyInfo                 ,
#endif
    clearMapFontDesc                        ,
    constructMapFontDesc                    ,
    getMapFontDesc                          ,
#if ENABLE_OVERLOADING
    mapFontDesc                             ,
#endif
    setMapFontDesc                          ,


-- ** view #attr:view#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    MapViewPropertyInfo                     ,
#endif
    constructMapView                        ,
    getMapView                              ,
#if ENABLE_OVERLOADING
    mapView                                 ,
#endif
    setMapView                              ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.Atk.Interfaces.ImplementorIface as Atk.ImplementorIface
import qualified GI.GObject.Objects.Object as GObject.Object
import qualified GI.Gtk.Interfaces.Buildable as Gtk.Buildable
import qualified GI.Gtk.Interfaces.Scrollable as Gtk.Scrollable
import qualified GI.Gtk.Objects.Container as Gtk.Container
import qualified GI.Gtk.Objects.TextView as Gtk.TextView
import qualified GI.Gtk.Objects.Widget as Gtk.Widget
import {-# SOURCE #-} qualified GI.GtkSource.Objects.View as GtkSource.View
import qualified GI.Pango.Structs.FontDescription as Pango.FontDescription

-- | Memory-managed wrapper type.
newtype Map = Map (ManagedPtr Map)
foreign import ccall "gtk_source_map_get_type"
    c_gtk_source_map_get_type :: IO GType

instance GObject Map where
    gobjectType = c_gtk_source_map_get_type
    

-- | Type class for types which can be safely cast to `Map`, for instance with `toMap`.
class (GObject o, O.IsDescendantOf Map o) => IsMap o
instance (GObject o, O.IsDescendantOf Map o) => IsMap o

instance O.HasParentTypes Map
type instance O.ParentTypes Map = '[GtkSource.View.View, Gtk.TextView.TextView, Gtk.Container.Container, Gtk.Widget.Widget, GObject.Object.Object, Atk.ImplementorIface.ImplementorIface, Gtk.Buildable.Buildable, Gtk.Scrollable.Scrollable]

-- | Cast to `Map`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toMap :: (MonadIO m, IsMap o) => o -> m Map
toMap = liftIO . unsafeCastTo Map

-- | A convenience alias for `Nothing` :: `Maybe` `Map`.
noMap :: Maybe Map
noMap = Nothing

#if ENABLE_OVERLOADING
type family ResolveMapMethod (t :: Symbol) (o :: *) :: * where
    ResolveMapMethod "activate" o = Gtk.Widget.WidgetActivateMethodInfo
    ResolveMapMethod "add" o = Gtk.Container.ContainerAddMethodInfo
    ResolveMapMethod "addAccelerator" o = Gtk.Widget.WidgetAddAcceleratorMethodInfo
    ResolveMapMethod "addChild" o = Gtk.Buildable.BuildableAddChildMethodInfo
    ResolveMapMethod "addChildAtAnchor" o = Gtk.TextView.TextViewAddChildAtAnchorMethodInfo
    ResolveMapMethod "addChildInWindow" o = Gtk.TextView.TextViewAddChildInWindowMethodInfo
    ResolveMapMethod "addDeviceEvents" o = Gtk.Widget.WidgetAddDeviceEventsMethodInfo
    ResolveMapMethod "addEvents" o = Gtk.Widget.WidgetAddEventsMethodInfo
    ResolveMapMethod "addMnemonicLabel" o = Gtk.Widget.WidgetAddMnemonicLabelMethodInfo
    ResolveMapMethod "addTickCallback" o = Gtk.Widget.WidgetAddTickCallbackMethodInfo
    ResolveMapMethod "backwardDisplayLine" o = Gtk.TextView.TextViewBackwardDisplayLineMethodInfo
    ResolveMapMethod "backwardDisplayLineStart" o = Gtk.TextView.TextViewBackwardDisplayLineStartMethodInfo
    ResolveMapMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveMapMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveMapMethod "bufferToWindowCoords" o = Gtk.TextView.TextViewBufferToWindowCoordsMethodInfo
    ResolveMapMethod "canActivateAccel" o = Gtk.Widget.WidgetCanActivateAccelMethodInfo
    ResolveMapMethod "checkResize" o = Gtk.Container.ContainerCheckResizeMethodInfo
    ResolveMapMethod "childFocus" o = Gtk.Widget.WidgetChildFocusMethodInfo
    ResolveMapMethod "childGetProperty" o = Gtk.Container.ContainerChildGetPropertyMethodInfo
    ResolveMapMethod "childNotify" o = Gtk.Container.ContainerChildNotifyMethodInfo
    ResolveMapMethod "childNotifyByPspec" o = Gtk.Container.ContainerChildNotifyByPspecMethodInfo
    ResolveMapMethod "childSetProperty" o = Gtk.Container.ContainerChildSetPropertyMethodInfo
    ResolveMapMethod "childType" o = Gtk.Container.ContainerChildTypeMethodInfo
    ResolveMapMethod "classPath" o = Gtk.Widget.WidgetClassPathMethodInfo
    ResolveMapMethod "computeExpand" o = Gtk.Widget.WidgetComputeExpandMethodInfo
    ResolveMapMethod "constructChild" o = Gtk.Buildable.BuildableConstructChildMethodInfo
    ResolveMapMethod "createPangoContext" o = Gtk.Widget.WidgetCreatePangoContextMethodInfo
    ResolveMapMethod "createPangoLayout" o = Gtk.Widget.WidgetCreatePangoLayoutMethodInfo
    ResolveMapMethod "customFinished" o = Gtk.Buildable.BuildableCustomFinishedMethodInfo
    ResolveMapMethod "customTagEnd" o = Gtk.Buildable.BuildableCustomTagEndMethodInfo
    ResolveMapMethod "customTagStart" o = Gtk.Buildable.BuildableCustomTagStartMethodInfo
    ResolveMapMethod "destroy" o = Gtk.Widget.WidgetDestroyMethodInfo
    ResolveMapMethod "destroyed" o = Gtk.Widget.WidgetDestroyedMethodInfo
    ResolveMapMethod "deviceIsShadowed" o = Gtk.Widget.WidgetDeviceIsShadowedMethodInfo
    ResolveMapMethod "dragBegin" o = Gtk.Widget.WidgetDragBeginMethodInfo
    ResolveMapMethod "dragBeginWithCoordinates" o = Gtk.Widget.WidgetDragBeginWithCoordinatesMethodInfo
    ResolveMapMethod "dragCheckThreshold" o = Gtk.Widget.WidgetDragCheckThresholdMethodInfo
    ResolveMapMethod "dragDestAddImageTargets" o = Gtk.Widget.WidgetDragDestAddImageTargetsMethodInfo
    ResolveMapMethod "dragDestAddTextTargets" o = Gtk.Widget.WidgetDragDestAddTextTargetsMethodInfo
    ResolveMapMethod "dragDestAddUriTargets" o = Gtk.Widget.WidgetDragDestAddUriTargetsMethodInfo
    ResolveMapMethod "dragDestFindTarget" o = Gtk.Widget.WidgetDragDestFindTargetMethodInfo
    ResolveMapMethod "dragDestGetTargetList" o = Gtk.Widget.WidgetDragDestGetTargetListMethodInfo
    ResolveMapMethod "dragDestGetTrackMotion" o = Gtk.Widget.WidgetDragDestGetTrackMotionMethodInfo
    ResolveMapMethod "dragDestSet" o = Gtk.Widget.WidgetDragDestSetMethodInfo
    ResolveMapMethod "dragDestSetProxy" o = Gtk.Widget.WidgetDragDestSetProxyMethodInfo
    ResolveMapMethod "dragDestSetTargetList" o = Gtk.Widget.WidgetDragDestSetTargetListMethodInfo
    ResolveMapMethod "dragDestSetTrackMotion" o = Gtk.Widget.WidgetDragDestSetTrackMotionMethodInfo
    ResolveMapMethod "dragDestUnset" o = Gtk.Widget.WidgetDragDestUnsetMethodInfo
    ResolveMapMethod "dragGetData" o = Gtk.Widget.WidgetDragGetDataMethodInfo
    ResolveMapMethod "dragHighlight" o = Gtk.Widget.WidgetDragHighlightMethodInfo
    ResolveMapMethod "dragSourceAddImageTargets" o = Gtk.Widget.WidgetDragSourceAddImageTargetsMethodInfo
    ResolveMapMethod "dragSourceAddTextTargets" o = Gtk.Widget.WidgetDragSourceAddTextTargetsMethodInfo
    ResolveMapMethod "dragSourceAddUriTargets" o = Gtk.Widget.WidgetDragSourceAddUriTargetsMethodInfo
    ResolveMapMethod "dragSourceGetTargetList" o = Gtk.Widget.WidgetDragSourceGetTargetListMethodInfo
    ResolveMapMethod "dragSourceSet" o = Gtk.Widget.WidgetDragSourceSetMethodInfo
    ResolveMapMethod "dragSourceSetIconGicon" o = Gtk.Widget.WidgetDragSourceSetIconGiconMethodInfo
    ResolveMapMethod "dragSourceSetIconName" o = Gtk.Widget.WidgetDragSourceSetIconNameMethodInfo
    ResolveMapMethod "dragSourceSetIconPixbuf" o = Gtk.Widget.WidgetDragSourceSetIconPixbufMethodInfo
    ResolveMapMethod "dragSourceSetIconStock" o = Gtk.Widget.WidgetDragSourceSetIconStockMethodInfo
    ResolveMapMethod "dragSourceSetTargetList" o = Gtk.Widget.WidgetDragSourceSetTargetListMethodInfo
    ResolveMapMethod "dragSourceUnset" o = Gtk.Widget.WidgetDragSourceUnsetMethodInfo
    ResolveMapMethod "dragUnhighlight" o = Gtk.Widget.WidgetDragUnhighlightMethodInfo
    ResolveMapMethod "draw" o = Gtk.Widget.WidgetDrawMethodInfo
    ResolveMapMethod "ensureStyle" o = Gtk.Widget.WidgetEnsureStyleMethodInfo
    ResolveMapMethod "errorBell" o = Gtk.Widget.WidgetErrorBellMethodInfo
    ResolveMapMethod "event" o = Gtk.Widget.WidgetEventMethodInfo
    ResolveMapMethod "forall" o = Gtk.Container.ContainerForallMethodInfo
    ResolveMapMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveMapMethod "foreach" o = Gtk.Container.ContainerForeachMethodInfo
    ResolveMapMethod "forwardDisplayLine" o = Gtk.TextView.TextViewForwardDisplayLineMethodInfo
    ResolveMapMethod "forwardDisplayLineEnd" o = Gtk.TextView.TextViewForwardDisplayLineEndMethodInfo
    ResolveMapMethod "freezeChildNotify" o = Gtk.Widget.WidgetFreezeChildNotifyMethodInfo
    ResolveMapMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveMapMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveMapMethod "grabAdd" o = Gtk.Widget.WidgetGrabAddMethodInfo
    ResolveMapMethod "grabDefault" o = Gtk.Widget.WidgetGrabDefaultMethodInfo
    ResolveMapMethod "grabFocus" o = Gtk.Widget.WidgetGrabFocusMethodInfo
    ResolveMapMethod "grabRemove" o = Gtk.Widget.WidgetGrabRemoveMethodInfo
    ResolveMapMethod "hasDefault" o = Gtk.Widget.WidgetHasDefaultMethodInfo
    ResolveMapMethod "hasFocus" o = Gtk.Widget.WidgetHasFocusMethodInfo
    ResolveMapMethod "hasGrab" o = Gtk.Widget.WidgetHasGrabMethodInfo
    ResolveMapMethod "hasRcStyle" o = Gtk.Widget.WidgetHasRcStyleMethodInfo
    ResolveMapMethod "hasScreen" o = Gtk.Widget.WidgetHasScreenMethodInfo
    ResolveMapMethod "hasVisibleFocus" o = Gtk.Widget.WidgetHasVisibleFocusMethodInfo
    ResolveMapMethod "hide" o = Gtk.Widget.WidgetHideMethodInfo
    ResolveMapMethod "hideOnDelete" o = Gtk.Widget.WidgetHideOnDeleteMethodInfo
    ResolveMapMethod "imContextFilterKeypress" o = Gtk.TextView.TextViewImContextFilterKeypressMethodInfo
    ResolveMapMethod "inDestruction" o = Gtk.Widget.WidgetInDestructionMethodInfo
    ResolveMapMethod "indentLines" o = GtkSource.View.ViewIndentLinesMethodInfo
    ResolveMapMethod "initTemplate" o = Gtk.Widget.WidgetInitTemplateMethodInfo
    ResolveMapMethod "inputShapeCombineRegion" o = Gtk.Widget.WidgetInputShapeCombineRegionMethodInfo
    ResolveMapMethod "insertActionGroup" o = Gtk.Widget.WidgetInsertActionGroupMethodInfo
    ResolveMapMethod "intersect" o = Gtk.Widget.WidgetIntersectMethodInfo
    ResolveMapMethod "isAncestor" o = Gtk.Widget.WidgetIsAncestorMethodInfo
    ResolveMapMethod "isComposited" o = Gtk.Widget.WidgetIsCompositedMethodInfo
    ResolveMapMethod "isDrawable" o = Gtk.Widget.WidgetIsDrawableMethodInfo
    ResolveMapMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveMapMethod "isFocus" o = Gtk.Widget.WidgetIsFocusMethodInfo
    ResolveMapMethod "isSensitive" o = Gtk.Widget.WidgetIsSensitiveMethodInfo
    ResolveMapMethod "isToplevel" o = Gtk.Widget.WidgetIsToplevelMethodInfo
    ResolveMapMethod "isVisible" o = Gtk.Widget.WidgetIsVisibleMethodInfo
    ResolveMapMethod "keynavFailed" o = Gtk.Widget.WidgetKeynavFailedMethodInfo
    ResolveMapMethod "listAccelClosures" o = Gtk.Widget.WidgetListAccelClosuresMethodInfo
    ResolveMapMethod "listActionPrefixes" o = Gtk.Widget.WidgetListActionPrefixesMethodInfo
    ResolveMapMethod "listMnemonicLabels" o = Gtk.Widget.WidgetListMnemonicLabelsMethodInfo
    ResolveMapMethod "map" o = Gtk.Widget.WidgetMapMethodInfo
    ResolveMapMethod "mnemonicActivate" o = Gtk.Widget.WidgetMnemonicActivateMethodInfo
    ResolveMapMethod "modifyBase" o = Gtk.Widget.WidgetModifyBaseMethodInfo
    ResolveMapMethod "modifyBg" o = Gtk.Widget.WidgetModifyBgMethodInfo
    ResolveMapMethod "modifyCursor" o = Gtk.Widget.WidgetModifyCursorMethodInfo
    ResolveMapMethod "modifyFg" o = Gtk.Widget.WidgetModifyFgMethodInfo
    ResolveMapMethod "modifyFont" o = Gtk.Widget.WidgetModifyFontMethodInfo
    ResolveMapMethod "modifyStyle" o = Gtk.Widget.WidgetModifyStyleMethodInfo
    ResolveMapMethod "modifyText" o = Gtk.Widget.WidgetModifyTextMethodInfo
    ResolveMapMethod "moveChild" o = Gtk.TextView.TextViewMoveChildMethodInfo
    ResolveMapMethod "moveMarkOnscreen" o = Gtk.TextView.TextViewMoveMarkOnscreenMethodInfo
    ResolveMapMethod "moveVisually" o = Gtk.TextView.TextViewMoveVisuallyMethodInfo
    ResolveMapMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveMapMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveMapMethod "overrideBackgroundColor" o = Gtk.Widget.WidgetOverrideBackgroundColorMethodInfo
    ResolveMapMethod "overrideColor" o = Gtk.Widget.WidgetOverrideColorMethodInfo
    ResolveMapMethod "overrideCursor" o = Gtk.Widget.WidgetOverrideCursorMethodInfo
    ResolveMapMethod "overrideFont" o = Gtk.Widget.WidgetOverrideFontMethodInfo
    ResolveMapMethod "overrideSymbolicColor" o = Gtk.Widget.WidgetOverrideSymbolicColorMethodInfo
    ResolveMapMethod "parserFinished" o = Gtk.Buildable.BuildableParserFinishedMethodInfo
    ResolveMapMethod "path" o = Gtk.Widget.WidgetPathMethodInfo
    ResolveMapMethod "placeCursorOnscreen" o = Gtk.TextView.TextViewPlaceCursorOnscreenMethodInfo
    ResolveMapMethod "propagateDraw" o = Gtk.Container.ContainerPropagateDrawMethodInfo
    ResolveMapMethod "queueAllocate" o = Gtk.Widget.WidgetQueueAllocateMethodInfo
    ResolveMapMethod "queueComputeExpand" o = Gtk.Widget.WidgetQueueComputeExpandMethodInfo
    ResolveMapMethod "queueDraw" o = Gtk.Widget.WidgetQueueDrawMethodInfo
    ResolveMapMethod "queueDrawArea" o = Gtk.Widget.WidgetQueueDrawAreaMethodInfo
    ResolveMapMethod "queueDrawRegion" o = Gtk.Widget.WidgetQueueDrawRegionMethodInfo
    ResolveMapMethod "queueResize" o = Gtk.Widget.WidgetQueueResizeMethodInfo
    ResolveMapMethod "queueResizeNoRedraw" o = Gtk.Widget.WidgetQueueResizeNoRedrawMethodInfo
    ResolveMapMethod "realize" o = Gtk.Widget.WidgetRealizeMethodInfo
    ResolveMapMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveMapMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveMapMethod "regionIntersect" o = Gtk.Widget.WidgetRegionIntersectMethodInfo
    ResolveMapMethod "registerWindow" o = Gtk.Widget.WidgetRegisterWindowMethodInfo
    ResolveMapMethod "remove" o = Gtk.Container.ContainerRemoveMethodInfo
    ResolveMapMethod "removeAccelerator" o = Gtk.Widget.WidgetRemoveAcceleratorMethodInfo
    ResolveMapMethod "removeMnemonicLabel" o = Gtk.Widget.WidgetRemoveMnemonicLabelMethodInfo
    ResolveMapMethod "removeTickCallback" o = Gtk.Widget.WidgetRemoveTickCallbackMethodInfo
    ResolveMapMethod "renderIcon" o = Gtk.Widget.WidgetRenderIconMethodInfo
    ResolveMapMethod "renderIconPixbuf" o = Gtk.Widget.WidgetRenderIconPixbufMethodInfo
    ResolveMapMethod "reparent" o = Gtk.Widget.WidgetReparentMethodInfo
    ResolveMapMethod "resetCursorBlink" o = Gtk.TextView.TextViewResetCursorBlinkMethodInfo
    ResolveMapMethod "resetImContext" o = Gtk.TextView.TextViewResetImContextMethodInfo
    ResolveMapMethod "resetRcStyles" o = Gtk.Widget.WidgetResetRcStylesMethodInfo
    ResolveMapMethod "resetStyle" o = Gtk.Widget.WidgetResetStyleMethodInfo
    ResolveMapMethod "resizeChildren" o = Gtk.Container.ContainerResizeChildrenMethodInfo
    ResolveMapMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveMapMethod "scrollMarkOnscreen" o = Gtk.TextView.TextViewScrollMarkOnscreenMethodInfo
    ResolveMapMethod "scrollToIter" o = Gtk.TextView.TextViewScrollToIterMethodInfo
    ResolveMapMethod "scrollToMark" o = Gtk.TextView.TextViewScrollToMarkMethodInfo
    ResolveMapMethod "sendExpose" o = Gtk.Widget.WidgetSendExposeMethodInfo
    ResolveMapMethod "sendFocusChange" o = Gtk.Widget.WidgetSendFocusChangeMethodInfo
    ResolveMapMethod "shapeCombineRegion" o = Gtk.Widget.WidgetShapeCombineRegionMethodInfo
    ResolveMapMethod "show" o = Gtk.Widget.WidgetShowMethodInfo
    ResolveMapMethod "showAll" o = Gtk.Widget.WidgetShowAllMethodInfo
    ResolveMapMethod "showNow" o = Gtk.Widget.WidgetShowNowMethodInfo
    ResolveMapMethod "sizeAllocate" o = Gtk.Widget.WidgetSizeAllocateMethodInfo
    ResolveMapMethod "sizeAllocateWithBaseline" o = Gtk.Widget.WidgetSizeAllocateWithBaselineMethodInfo
    ResolveMapMethod "sizeRequest" o = Gtk.Widget.WidgetSizeRequestMethodInfo
    ResolveMapMethod "startsDisplayLine" o = Gtk.TextView.TextViewStartsDisplayLineMethodInfo
    ResolveMapMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveMapMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveMapMethod "styleAttach" o = Gtk.Widget.WidgetStyleAttachMethodInfo
    ResolveMapMethod "styleGetProperty" o = Gtk.Widget.WidgetStyleGetPropertyMethodInfo
    ResolveMapMethod "thawChildNotify" o = Gtk.Widget.WidgetThawChildNotifyMethodInfo
    ResolveMapMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveMapMethod "translateCoordinates" o = Gtk.Widget.WidgetTranslateCoordinatesMethodInfo
    ResolveMapMethod "triggerTooltipQuery" o = Gtk.Widget.WidgetTriggerTooltipQueryMethodInfo
    ResolveMapMethod "unindentLines" o = GtkSource.View.ViewUnindentLinesMethodInfo
    ResolveMapMethod "unmap" o = Gtk.Widget.WidgetUnmapMethodInfo
    ResolveMapMethod "unparent" o = Gtk.Widget.WidgetUnparentMethodInfo
    ResolveMapMethod "unrealize" o = Gtk.Widget.WidgetUnrealizeMethodInfo
    ResolveMapMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveMapMethod "unregisterWindow" o = Gtk.Widget.WidgetUnregisterWindowMethodInfo
    ResolveMapMethod "unsetFocusChain" o = Gtk.Container.ContainerUnsetFocusChainMethodInfo
    ResolveMapMethod "unsetStateFlags" o = Gtk.Widget.WidgetUnsetStateFlagsMethodInfo
    ResolveMapMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveMapMethod "windowToBufferCoords" o = Gtk.TextView.TextViewWindowToBufferCoordsMethodInfo
    ResolveMapMethod "getAcceptsTab" o = Gtk.TextView.TextViewGetAcceptsTabMethodInfo
    ResolveMapMethod "getAccessible" o = Gtk.Widget.WidgetGetAccessibleMethodInfo
    ResolveMapMethod "getActionGroup" o = Gtk.Widget.WidgetGetActionGroupMethodInfo
    ResolveMapMethod "getAllocatedBaseline" o = Gtk.Widget.WidgetGetAllocatedBaselineMethodInfo
    ResolveMapMethod "getAllocatedHeight" o = Gtk.Widget.WidgetGetAllocatedHeightMethodInfo
    ResolveMapMethod "getAllocatedSize" o = Gtk.Widget.WidgetGetAllocatedSizeMethodInfo
    ResolveMapMethod "getAllocatedWidth" o = Gtk.Widget.WidgetGetAllocatedWidthMethodInfo
    ResolveMapMethod "getAllocation" o = Gtk.Widget.WidgetGetAllocationMethodInfo
    ResolveMapMethod "getAncestor" o = Gtk.Widget.WidgetGetAncestorMethodInfo
    ResolveMapMethod "getAppPaintable" o = Gtk.Widget.WidgetGetAppPaintableMethodInfo
    ResolveMapMethod "getAutoIndent" o = GtkSource.View.ViewGetAutoIndentMethodInfo
    ResolveMapMethod "getBackgroundPattern" o = GtkSource.View.ViewGetBackgroundPatternMethodInfo
    ResolveMapMethod "getBorder" o = Gtk.Scrollable.ScrollableGetBorderMethodInfo
    ResolveMapMethod "getBorderWidth" o = Gtk.Container.ContainerGetBorderWidthMethodInfo
    ResolveMapMethod "getBorderWindowSize" o = Gtk.TextView.TextViewGetBorderWindowSizeMethodInfo
    ResolveMapMethod "getBottomMargin" o = Gtk.TextView.TextViewGetBottomMarginMethodInfo
    ResolveMapMethod "getBuffer" o = Gtk.TextView.TextViewGetBufferMethodInfo
    ResolveMapMethod "getCanDefault" o = Gtk.Widget.WidgetGetCanDefaultMethodInfo
    ResolveMapMethod "getCanFocus" o = Gtk.Widget.WidgetGetCanFocusMethodInfo
    ResolveMapMethod "getChildRequisition" o = Gtk.Widget.WidgetGetChildRequisitionMethodInfo
    ResolveMapMethod "getChildVisible" o = Gtk.Widget.WidgetGetChildVisibleMethodInfo
    ResolveMapMethod "getChildren" o = Gtk.Container.ContainerGetChildrenMethodInfo
    ResolveMapMethod "getClip" o = Gtk.Widget.WidgetGetClipMethodInfo
    ResolveMapMethod "getClipboard" o = Gtk.Widget.WidgetGetClipboardMethodInfo
    ResolveMapMethod "getCompletion" o = GtkSource.View.ViewGetCompletionMethodInfo
    ResolveMapMethod "getCompositeName" o = Gtk.Widget.WidgetGetCompositeNameMethodInfo
    ResolveMapMethod "getCursorLocations" o = Gtk.TextView.TextViewGetCursorLocationsMethodInfo
    ResolveMapMethod "getCursorVisible" o = Gtk.TextView.TextViewGetCursorVisibleMethodInfo
    ResolveMapMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveMapMethod "getDefaultAttributes" o = Gtk.TextView.TextViewGetDefaultAttributesMethodInfo
    ResolveMapMethod "getDeviceEnabled" o = Gtk.Widget.WidgetGetDeviceEnabledMethodInfo
    ResolveMapMethod "getDeviceEvents" o = Gtk.Widget.WidgetGetDeviceEventsMethodInfo
    ResolveMapMethod "getDirection" o = Gtk.Widget.WidgetGetDirectionMethodInfo
    ResolveMapMethod "getDisplay" o = Gtk.Widget.WidgetGetDisplayMethodInfo
    ResolveMapMethod "getDoubleBuffered" o = Gtk.Widget.WidgetGetDoubleBufferedMethodInfo
    ResolveMapMethod "getDrawSpaces" o = GtkSource.View.ViewGetDrawSpacesMethodInfo
    ResolveMapMethod "getEditable" o = Gtk.TextView.TextViewGetEditableMethodInfo
    ResolveMapMethod "getEvents" o = Gtk.Widget.WidgetGetEventsMethodInfo
    ResolveMapMethod "getFocusChain" o = Gtk.Container.ContainerGetFocusChainMethodInfo
    ResolveMapMethod "getFocusChild" o = Gtk.Container.ContainerGetFocusChildMethodInfo
    ResolveMapMethod "getFocusHadjustment" o = Gtk.Container.ContainerGetFocusHadjustmentMethodInfo
    ResolveMapMethod "getFocusOnClick" o = Gtk.Widget.WidgetGetFocusOnClickMethodInfo
    ResolveMapMethod "getFocusVadjustment" o = Gtk.Container.ContainerGetFocusVadjustmentMethodInfo
    ResolveMapMethod "getFontMap" o = Gtk.Widget.WidgetGetFontMapMethodInfo
    ResolveMapMethod "getFontOptions" o = Gtk.Widget.WidgetGetFontOptionsMethodInfo
    ResolveMapMethod "getFrameClock" o = Gtk.Widget.WidgetGetFrameClockMethodInfo
    ResolveMapMethod "getGutter" o = GtkSource.View.ViewGetGutterMethodInfo
    ResolveMapMethod "getHadjustment" o = Gtk.TextView.TextViewGetHadjustmentMethodInfo
    ResolveMapMethod "getHalign" o = Gtk.Widget.WidgetGetHalignMethodInfo
    ResolveMapMethod "getHasTooltip" o = Gtk.Widget.WidgetGetHasTooltipMethodInfo
    ResolveMapMethod "getHasWindow" o = Gtk.Widget.WidgetGetHasWindowMethodInfo
    ResolveMapMethod "getHexpand" o = Gtk.Widget.WidgetGetHexpandMethodInfo
    ResolveMapMethod "getHexpandSet" o = Gtk.Widget.WidgetGetHexpandSetMethodInfo
    ResolveMapMethod "getHighlightCurrentLine" o = GtkSource.View.ViewGetHighlightCurrentLineMethodInfo
    ResolveMapMethod "getHscrollPolicy" o = Gtk.Scrollable.ScrollableGetHscrollPolicyMethodInfo
    ResolveMapMethod "getIndent" o = Gtk.TextView.TextViewGetIndentMethodInfo
    ResolveMapMethod "getIndentOnTab" o = GtkSource.View.ViewGetIndentOnTabMethodInfo
    ResolveMapMethod "getIndentWidth" o = GtkSource.View.ViewGetIndentWidthMethodInfo
    ResolveMapMethod "getInputHints" o = Gtk.TextView.TextViewGetInputHintsMethodInfo
    ResolveMapMethod "getInputPurpose" o = Gtk.TextView.TextViewGetInputPurposeMethodInfo
    ResolveMapMethod "getInsertSpacesInsteadOfTabs" o = GtkSource.View.ViewGetInsertSpacesInsteadOfTabsMethodInfo
    ResolveMapMethod "getInternalChild" o = Gtk.Buildable.BuildableGetInternalChildMethodInfo
    ResolveMapMethod "getIterAtLocation" o = Gtk.TextView.TextViewGetIterAtLocationMethodInfo
    ResolveMapMethod "getIterAtPosition" o = Gtk.TextView.TextViewGetIterAtPositionMethodInfo
    ResolveMapMethod "getIterLocation" o = Gtk.TextView.TextViewGetIterLocationMethodInfo
    ResolveMapMethod "getJustification" o = Gtk.TextView.TextViewGetJustificationMethodInfo
    ResolveMapMethod "getLeftMargin" o = Gtk.TextView.TextViewGetLeftMarginMethodInfo
    ResolveMapMethod "getLineAtY" o = Gtk.TextView.TextViewGetLineAtYMethodInfo
    ResolveMapMethod "getLineYrange" o = Gtk.TextView.TextViewGetLineYrangeMethodInfo
    ResolveMapMethod "getMapped" o = Gtk.Widget.WidgetGetMappedMethodInfo
    ResolveMapMethod "getMarginBottom" o = Gtk.Widget.WidgetGetMarginBottomMethodInfo
    ResolveMapMethod "getMarginEnd" o = Gtk.Widget.WidgetGetMarginEndMethodInfo
    ResolveMapMethod "getMarginLeft" o = Gtk.Widget.WidgetGetMarginLeftMethodInfo
    ResolveMapMethod "getMarginRight" o = Gtk.Widget.WidgetGetMarginRightMethodInfo
    ResolveMapMethod "getMarginStart" o = Gtk.Widget.WidgetGetMarginStartMethodInfo
    ResolveMapMethod "getMarginTop" o = Gtk.Widget.WidgetGetMarginTopMethodInfo
    ResolveMapMethod "getMarkAttributes" o = GtkSource.View.ViewGetMarkAttributesMethodInfo
    ResolveMapMethod "getModifierMask" o = Gtk.Widget.WidgetGetModifierMaskMethodInfo
    ResolveMapMethod "getModifierStyle" o = Gtk.Widget.WidgetGetModifierStyleMethodInfo
    ResolveMapMethod "getMonospace" o = Gtk.TextView.TextViewGetMonospaceMethodInfo
    ResolveMapMethod "getName" o = Gtk.Widget.WidgetGetNameMethodInfo
    ResolveMapMethod "getNoShowAll" o = Gtk.Widget.WidgetGetNoShowAllMethodInfo
    ResolveMapMethod "getOpacity" o = Gtk.Widget.WidgetGetOpacityMethodInfo
    ResolveMapMethod "getOverwrite" o = Gtk.TextView.TextViewGetOverwriteMethodInfo
    ResolveMapMethod "getPangoContext" o = Gtk.Widget.WidgetGetPangoContextMethodInfo
    ResolveMapMethod "getParent" o = Gtk.Widget.WidgetGetParentMethodInfo
    ResolveMapMethod "getParentWindow" o = Gtk.Widget.WidgetGetParentWindowMethodInfo
    ResolveMapMethod "getPath" o = Gtk.Widget.WidgetGetPathMethodInfo
    ResolveMapMethod "getPathForChild" o = Gtk.Container.ContainerGetPathForChildMethodInfo
    ResolveMapMethod "getPixelsAboveLines" o = Gtk.TextView.TextViewGetPixelsAboveLinesMethodInfo
    ResolveMapMethod "getPixelsBelowLines" o = Gtk.TextView.TextViewGetPixelsBelowLinesMethodInfo
    ResolveMapMethod "getPixelsInsideWrap" o = Gtk.TextView.TextViewGetPixelsInsideWrapMethodInfo
    ResolveMapMethod "getPointer" o = Gtk.Widget.WidgetGetPointerMethodInfo
    ResolveMapMethod "getPreferredHeight" o = Gtk.Widget.WidgetGetPreferredHeightMethodInfo
    ResolveMapMethod "getPreferredHeightAndBaselineForWidth" o = Gtk.Widget.WidgetGetPreferredHeightAndBaselineForWidthMethodInfo
    ResolveMapMethod "getPreferredHeightForWidth" o = Gtk.Widget.WidgetGetPreferredHeightForWidthMethodInfo
    ResolveMapMethod "getPreferredSize" o = Gtk.Widget.WidgetGetPreferredSizeMethodInfo
    ResolveMapMethod "getPreferredWidth" o = Gtk.Widget.WidgetGetPreferredWidthMethodInfo
    ResolveMapMethod "getPreferredWidthForHeight" o = Gtk.Widget.WidgetGetPreferredWidthForHeightMethodInfo
    ResolveMapMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveMapMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveMapMethod "getRealized" o = Gtk.Widget.WidgetGetRealizedMethodInfo
    ResolveMapMethod "getReceivesDefault" o = Gtk.Widget.WidgetGetReceivesDefaultMethodInfo
    ResolveMapMethod "getRequestMode" o = Gtk.Widget.WidgetGetRequestModeMethodInfo
    ResolveMapMethod "getRequisition" o = Gtk.Widget.WidgetGetRequisitionMethodInfo
    ResolveMapMethod "getResizeMode" o = Gtk.Container.ContainerGetResizeModeMethodInfo
    ResolveMapMethod "getRightMargin" o = Gtk.TextView.TextViewGetRightMarginMethodInfo
    ResolveMapMethod "getRightMarginPosition" o = GtkSource.View.ViewGetRightMarginPositionMethodInfo
    ResolveMapMethod "getRootWindow" o = Gtk.Widget.WidgetGetRootWindowMethodInfo
    ResolveMapMethod "getScaleFactor" o = Gtk.Widget.WidgetGetScaleFactorMethodInfo
    ResolveMapMethod "getScreen" o = Gtk.Widget.WidgetGetScreenMethodInfo
    ResolveMapMethod "getSensitive" o = Gtk.Widget.WidgetGetSensitiveMethodInfo
    ResolveMapMethod "getSettings" o = Gtk.Widget.WidgetGetSettingsMethodInfo
    ResolveMapMethod "getShowLineMarks" o = GtkSource.View.ViewGetShowLineMarksMethodInfo
    ResolveMapMethod "getShowLineNumbers" o = GtkSource.View.ViewGetShowLineNumbersMethodInfo
    ResolveMapMethod "getShowRightMargin" o = GtkSource.View.ViewGetShowRightMarginMethodInfo
    ResolveMapMethod "getSizeRequest" o = Gtk.Widget.WidgetGetSizeRequestMethodInfo
    ResolveMapMethod "getSmartBackspace" o = GtkSource.View.ViewGetSmartBackspaceMethodInfo
    ResolveMapMethod "getSmartHomeEnd" o = GtkSource.View.ViewGetSmartHomeEndMethodInfo
    ResolveMapMethod "getSpaceDrawer" o = GtkSource.View.ViewGetSpaceDrawerMethodInfo
    ResolveMapMethod "getState" o = Gtk.Widget.WidgetGetStateMethodInfo
    ResolveMapMethod "getStateFlags" o = Gtk.Widget.WidgetGetStateFlagsMethodInfo
    ResolveMapMethod "getStyle" o = Gtk.Widget.WidgetGetStyleMethodInfo
    ResolveMapMethod "getStyleContext" o = Gtk.Widget.WidgetGetStyleContextMethodInfo
    ResolveMapMethod "getSupportMultidevice" o = Gtk.Widget.WidgetGetSupportMultideviceMethodInfo
    ResolveMapMethod "getTabWidth" o = GtkSource.View.ViewGetTabWidthMethodInfo
    ResolveMapMethod "getTabs" o = Gtk.TextView.TextViewGetTabsMethodInfo
    ResolveMapMethod "getTemplateChild" o = Gtk.Widget.WidgetGetTemplateChildMethodInfo
    ResolveMapMethod "getTooltipMarkup" o = Gtk.Widget.WidgetGetTooltipMarkupMethodInfo
    ResolveMapMethod "getTooltipText" o = Gtk.Widget.WidgetGetTooltipTextMethodInfo
    ResolveMapMethod "getTooltipWindow" o = Gtk.Widget.WidgetGetTooltipWindowMethodInfo
    ResolveMapMethod "getTopMargin" o = Gtk.TextView.TextViewGetTopMarginMethodInfo
    ResolveMapMethod "getToplevel" o = Gtk.Widget.WidgetGetToplevelMethodInfo
    ResolveMapMethod "getVadjustment" o = Gtk.TextView.TextViewGetVadjustmentMethodInfo
    ResolveMapMethod "getValign" o = Gtk.Widget.WidgetGetValignMethodInfo
    ResolveMapMethod "getValignWithBaseline" o = Gtk.Widget.WidgetGetValignWithBaselineMethodInfo
    ResolveMapMethod "getVexpand" o = Gtk.Widget.WidgetGetVexpandMethodInfo
    ResolveMapMethod "getVexpandSet" o = Gtk.Widget.WidgetGetVexpandSetMethodInfo
    ResolveMapMethod "getView" o = MapGetViewMethodInfo
    ResolveMapMethod "getVisible" o = Gtk.Widget.WidgetGetVisibleMethodInfo
    ResolveMapMethod "getVisibleRect" o = Gtk.TextView.TextViewGetVisibleRectMethodInfo
    ResolveMapMethod "getVisual" o = Gtk.Widget.WidgetGetVisualMethodInfo
    ResolveMapMethod "getVisualColumn" o = GtkSource.View.ViewGetVisualColumnMethodInfo
    ResolveMapMethod "getVscrollPolicy" o = Gtk.Scrollable.ScrollableGetVscrollPolicyMethodInfo
    ResolveMapMethod "getWindow" o = Gtk.TextView.TextViewGetWindowMethodInfo
    ResolveMapMethod "getWindowType" o = Gtk.TextView.TextViewGetWindowTypeMethodInfo
    ResolveMapMethod "getWrapMode" o = Gtk.TextView.TextViewGetWrapModeMethodInfo
    ResolveMapMethod "setAccelPath" o = Gtk.Widget.WidgetSetAccelPathMethodInfo
    ResolveMapMethod "setAcceptsTab" o = Gtk.TextView.TextViewSetAcceptsTabMethodInfo
    ResolveMapMethod "setAllocation" o = Gtk.Widget.WidgetSetAllocationMethodInfo
    ResolveMapMethod "setAppPaintable" o = Gtk.Widget.WidgetSetAppPaintableMethodInfo
    ResolveMapMethod "setAutoIndent" o = GtkSource.View.ViewSetAutoIndentMethodInfo
    ResolveMapMethod "setBackgroundPattern" o = GtkSource.View.ViewSetBackgroundPatternMethodInfo
    ResolveMapMethod "setBorderWidth" o = Gtk.Container.ContainerSetBorderWidthMethodInfo
    ResolveMapMethod "setBorderWindowSize" o = Gtk.TextView.TextViewSetBorderWindowSizeMethodInfo
    ResolveMapMethod "setBottomMargin" o = Gtk.TextView.TextViewSetBottomMarginMethodInfo
    ResolveMapMethod "setBuffer" o = Gtk.TextView.TextViewSetBufferMethodInfo
    ResolveMapMethod "setBuildableProperty" o = Gtk.Buildable.BuildableSetBuildablePropertyMethodInfo
    ResolveMapMethod "setCanDefault" o = Gtk.Widget.WidgetSetCanDefaultMethodInfo
    ResolveMapMethod "setCanFocus" o = Gtk.Widget.WidgetSetCanFocusMethodInfo
    ResolveMapMethod "setChildVisible" o = Gtk.Widget.WidgetSetChildVisibleMethodInfo
    ResolveMapMethod "setClip" o = Gtk.Widget.WidgetSetClipMethodInfo
    ResolveMapMethod "setCompositeName" o = Gtk.Widget.WidgetSetCompositeNameMethodInfo
    ResolveMapMethod "setCursorVisible" o = Gtk.TextView.TextViewSetCursorVisibleMethodInfo
    ResolveMapMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveMapMethod "setDeviceEnabled" o = Gtk.Widget.WidgetSetDeviceEnabledMethodInfo
    ResolveMapMethod "setDeviceEvents" o = Gtk.Widget.WidgetSetDeviceEventsMethodInfo
    ResolveMapMethod "setDirection" o = Gtk.Widget.WidgetSetDirectionMethodInfo
    ResolveMapMethod "setDoubleBuffered" o = Gtk.Widget.WidgetSetDoubleBufferedMethodInfo
    ResolveMapMethod "setDrawSpaces" o = GtkSource.View.ViewSetDrawSpacesMethodInfo
    ResolveMapMethod "setEditable" o = Gtk.TextView.TextViewSetEditableMethodInfo
    ResolveMapMethod "setEvents" o = Gtk.Widget.WidgetSetEventsMethodInfo
    ResolveMapMethod "setFocusChain" o = Gtk.Container.ContainerSetFocusChainMethodInfo
    ResolveMapMethod "setFocusChild" o = Gtk.Container.ContainerSetFocusChildMethodInfo
    ResolveMapMethod "setFocusHadjustment" o = Gtk.Container.ContainerSetFocusHadjustmentMethodInfo
    ResolveMapMethod "setFocusOnClick" o = Gtk.Widget.WidgetSetFocusOnClickMethodInfo
    ResolveMapMethod "setFocusVadjustment" o = Gtk.Container.ContainerSetFocusVadjustmentMethodInfo
    ResolveMapMethod "setFontMap" o = Gtk.Widget.WidgetSetFontMapMethodInfo
    ResolveMapMethod "setFontOptions" o = Gtk.Widget.WidgetSetFontOptionsMethodInfo
    ResolveMapMethod "setHadjustment" o = Gtk.Scrollable.ScrollableSetHadjustmentMethodInfo
    ResolveMapMethod "setHalign" o = Gtk.Widget.WidgetSetHalignMethodInfo
    ResolveMapMethod "setHasTooltip" o = Gtk.Widget.WidgetSetHasTooltipMethodInfo
    ResolveMapMethod "setHasWindow" o = Gtk.Widget.WidgetSetHasWindowMethodInfo
    ResolveMapMethod "setHexpand" o = Gtk.Widget.WidgetSetHexpandMethodInfo
    ResolveMapMethod "setHexpandSet" o = Gtk.Widget.WidgetSetHexpandSetMethodInfo
    ResolveMapMethod "setHighlightCurrentLine" o = GtkSource.View.ViewSetHighlightCurrentLineMethodInfo
    ResolveMapMethod "setHscrollPolicy" o = Gtk.Scrollable.ScrollableSetHscrollPolicyMethodInfo
    ResolveMapMethod "setIndent" o = Gtk.TextView.TextViewSetIndentMethodInfo
    ResolveMapMethod "setIndentOnTab" o = GtkSource.View.ViewSetIndentOnTabMethodInfo
    ResolveMapMethod "setIndentWidth" o = GtkSource.View.ViewSetIndentWidthMethodInfo
    ResolveMapMethod "setInputHints" o = Gtk.TextView.TextViewSetInputHintsMethodInfo
    ResolveMapMethod "setInputPurpose" o = Gtk.TextView.TextViewSetInputPurposeMethodInfo
    ResolveMapMethod "setInsertSpacesInsteadOfTabs" o = GtkSource.View.ViewSetInsertSpacesInsteadOfTabsMethodInfo
    ResolveMapMethod "setJustification" o = Gtk.TextView.TextViewSetJustificationMethodInfo
    ResolveMapMethod "setLeftMargin" o = Gtk.TextView.TextViewSetLeftMarginMethodInfo
    ResolveMapMethod "setMapped" o = Gtk.Widget.WidgetSetMappedMethodInfo
    ResolveMapMethod "setMarginBottom" o = Gtk.Widget.WidgetSetMarginBottomMethodInfo
    ResolveMapMethod "setMarginEnd" o = Gtk.Widget.WidgetSetMarginEndMethodInfo
    ResolveMapMethod "setMarginLeft" o = Gtk.Widget.WidgetSetMarginLeftMethodInfo
    ResolveMapMethod "setMarginRight" o = Gtk.Widget.WidgetSetMarginRightMethodInfo
    ResolveMapMethod "setMarginStart" o = Gtk.Widget.WidgetSetMarginStartMethodInfo
    ResolveMapMethod "setMarginTop" o = Gtk.Widget.WidgetSetMarginTopMethodInfo
    ResolveMapMethod "setMarkAttributes" o = GtkSource.View.ViewSetMarkAttributesMethodInfo
    ResolveMapMethod "setMonospace" o = Gtk.TextView.TextViewSetMonospaceMethodInfo
    ResolveMapMethod "setName" o = Gtk.Widget.WidgetSetNameMethodInfo
    ResolveMapMethod "setNoShowAll" o = Gtk.Widget.WidgetSetNoShowAllMethodInfo
    ResolveMapMethod "setOpacity" o = Gtk.Widget.WidgetSetOpacityMethodInfo
    ResolveMapMethod "setOverwrite" o = Gtk.TextView.TextViewSetOverwriteMethodInfo
    ResolveMapMethod "setParent" o = Gtk.Widget.WidgetSetParentMethodInfo
    ResolveMapMethod "setParentWindow" o = Gtk.Widget.WidgetSetParentWindowMethodInfo
    ResolveMapMethod "setPixelsAboveLines" o = Gtk.TextView.TextViewSetPixelsAboveLinesMethodInfo
    ResolveMapMethod "setPixelsBelowLines" o = Gtk.TextView.TextViewSetPixelsBelowLinesMethodInfo
    ResolveMapMethod "setPixelsInsideWrap" o = Gtk.TextView.TextViewSetPixelsInsideWrapMethodInfo
    ResolveMapMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveMapMethod "setRealized" o = Gtk.Widget.WidgetSetRealizedMethodInfo
    ResolveMapMethod "setReallocateRedraws" o = Gtk.Container.ContainerSetReallocateRedrawsMethodInfo
    ResolveMapMethod "setReceivesDefault" o = Gtk.Widget.WidgetSetReceivesDefaultMethodInfo
    ResolveMapMethod "setRedrawOnAllocate" o = Gtk.Widget.WidgetSetRedrawOnAllocateMethodInfo
    ResolveMapMethod "setResizeMode" o = Gtk.Container.ContainerSetResizeModeMethodInfo
    ResolveMapMethod "setRightMargin" o = Gtk.TextView.TextViewSetRightMarginMethodInfo
    ResolveMapMethod "setRightMarginPosition" o = GtkSource.View.ViewSetRightMarginPositionMethodInfo
    ResolveMapMethod "setSensitive" o = Gtk.Widget.WidgetSetSensitiveMethodInfo
    ResolveMapMethod "setShowLineMarks" o = GtkSource.View.ViewSetShowLineMarksMethodInfo
    ResolveMapMethod "setShowLineNumbers" o = GtkSource.View.ViewSetShowLineNumbersMethodInfo
    ResolveMapMethod "setShowRightMargin" o = GtkSource.View.ViewSetShowRightMarginMethodInfo
    ResolveMapMethod "setSizeRequest" o = Gtk.Widget.WidgetSetSizeRequestMethodInfo
    ResolveMapMethod "setSmartBackspace" o = GtkSource.View.ViewSetSmartBackspaceMethodInfo
    ResolveMapMethod "setSmartHomeEnd" o = GtkSource.View.ViewSetSmartHomeEndMethodInfo
    ResolveMapMethod "setState" o = Gtk.Widget.WidgetSetStateMethodInfo
    ResolveMapMethod "setStateFlags" o = Gtk.Widget.WidgetSetStateFlagsMethodInfo
    ResolveMapMethod "setStyle" o = Gtk.Widget.WidgetSetStyleMethodInfo
    ResolveMapMethod "setSupportMultidevice" o = Gtk.Widget.WidgetSetSupportMultideviceMethodInfo
    ResolveMapMethod "setTabWidth" o = GtkSource.View.ViewSetTabWidthMethodInfo
    ResolveMapMethod "setTabs" o = Gtk.TextView.TextViewSetTabsMethodInfo
    ResolveMapMethod "setTooltipMarkup" o = Gtk.Widget.WidgetSetTooltipMarkupMethodInfo
    ResolveMapMethod "setTooltipText" o = Gtk.Widget.WidgetSetTooltipTextMethodInfo
    ResolveMapMethod "setTooltipWindow" o = Gtk.Widget.WidgetSetTooltipWindowMethodInfo
    ResolveMapMethod "setTopMargin" o = Gtk.TextView.TextViewSetTopMarginMethodInfo
    ResolveMapMethod "setVadjustment" o = Gtk.Scrollable.ScrollableSetVadjustmentMethodInfo
    ResolveMapMethod "setValign" o = Gtk.Widget.WidgetSetValignMethodInfo
    ResolveMapMethod "setVexpand" o = Gtk.Widget.WidgetSetVexpandMethodInfo
    ResolveMapMethod "setVexpandSet" o = Gtk.Widget.WidgetSetVexpandSetMethodInfo
    ResolveMapMethod "setView" o = MapSetViewMethodInfo
    ResolveMapMethod "setVisible" o = Gtk.Widget.WidgetSetVisibleMethodInfo
    ResolveMapMethod "setVisual" o = Gtk.Widget.WidgetSetVisualMethodInfo
    ResolveMapMethod "setVscrollPolicy" o = Gtk.Scrollable.ScrollableSetVscrollPolicyMethodInfo
    ResolveMapMethod "setWindow" o = Gtk.Widget.WidgetSetWindowMethodInfo
    ResolveMapMethod "setWrapMode" o = Gtk.TextView.TextViewSetWrapModeMethodInfo
    ResolveMapMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveMapMethod t Map, O.MethodInfo info Map p) => OL.IsLabel t (Map -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

-- VVV Prop "font-desc"
   -- Type: TInterface (Name {namespace = "Pango", name = "FontDescription"})
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@font-desc@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' map #fontDesc
@
-}
getMapFontDesc :: (MonadIO m, IsMap o) => o -> m (Maybe Pango.FontDescription.FontDescription)
getMapFontDesc obj = liftIO $ B.Properties.getObjectPropertyBoxed obj "font-desc" Pango.FontDescription.FontDescription

{- |
Set the value of the “@font-desc@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' map [ #fontDesc 'Data.GI.Base.Attributes.:=' value ]
@
-}
setMapFontDesc :: (MonadIO m, IsMap o) => o -> Pango.FontDescription.FontDescription -> m ()
setMapFontDesc obj val = liftIO $ B.Properties.setObjectPropertyBoxed obj "font-desc" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@font-desc@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructMapFontDesc :: (IsMap o) => Pango.FontDescription.FontDescription -> IO (GValueConstruct o)
constructMapFontDesc val = B.Properties.constructObjectPropertyBoxed "font-desc" (Just val)

{- |
Set the value of the “@font-desc@” property to `Nothing`.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.clear' #fontDesc
@
-}
clearMapFontDesc :: (MonadIO m, IsMap o) => o -> m ()
clearMapFontDesc obj = liftIO $ B.Properties.setObjectPropertyBoxed obj "font-desc" (Nothing :: Maybe Pango.FontDescription.FontDescription)

#if ENABLE_OVERLOADING
data MapFontDescPropertyInfo
instance AttrInfo MapFontDescPropertyInfo where
    type AttrAllowedOps MapFontDescPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint MapFontDescPropertyInfo = (~) Pango.FontDescription.FontDescription
    type AttrBaseTypeConstraint MapFontDescPropertyInfo = IsMap
    type AttrGetType MapFontDescPropertyInfo = (Maybe Pango.FontDescription.FontDescription)
    type AttrLabel MapFontDescPropertyInfo = "font-desc"
    type AttrOrigin MapFontDescPropertyInfo = Map
    attrGet _ = getMapFontDesc
    attrSet _ = setMapFontDesc
    attrConstruct _ = constructMapFontDesc
    attrClear _ = clearMapFontDesc
#endif

-- VVV Prop "view"
   -- Type: TInterface (Name {namespace = "GtkSource", name = "View"})
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Just True,Just False)

{- |
Get the value of the “@view@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' map #view
@
-}
getMapView :: (MonadIO m, IsMap o) => o -> m (Maybe GtkSource.View.View)
getMapView obj = liftIO $ B.Properties.getObjectPropertyObject obj "view" GtkSource.View.View

{- |
Set the value of the “@view@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' map [ #view 'Data.GI.Base.Attributes.:=' value ]
@
-}
setMapView :: (MonadIO m, IsMap o, GtkSource.View.IsView a) => o -> a -> m ()
setMapView obj val = liftIO $ B.Properties.setObjectPropertyObject obj "view" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@view@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructMapView :: (IsMap o, GtkSource.View.IsView a) => a -> IO (GValueConstruct o)
constructMapView val = B.Properties.constructObjectPropertyObject "view" (Just val)

#if ENABLE_OVERLOADING
data MapViewPropertyInfo
instance AttrInfo MapViewPropertyInfo where
    type AttrAllowedOps MapViewPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint MapViewPropertyInfo = GtkSource.View.IsView
    type AttrBaseTypeConstraint MapViewPropertyInfo = IsMap
    type AttrGetType MapViewPropertyInfo = (Maybe GtkSource.View.View)
    type AttrLabel MapViewPropertyInfo = "view"
    type AttrOrigin MapViewPropertyInfo = Map
    attrGet _ = getMapView
    attrSet _ = setMapView
    attrConstruct _ = constructMapView
    attrClear _ = undefined
#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList Map
type instance O.AttributeList Map = MapAttributeList
type MapAttributeList = ('[ '("acceptsTab", Gtk.TextView.TextViewAcceptsTabPropertyInfo), '("appPaintable", Gtk.Widget.WidgetAppPaintablePropertyInfo), '("autoIndent", GtkSource.View.ViewAutoIndentPropertyInfo), '("backgroundPattern", GtkSource.View.ViewBackgroundPatternPropertyInfo), '("borderWidth", Gtk.Container.ContainerBorderWidthPropertyInfo), '("bottomMargin", Gtk.TextView.TextViewBottomMarginPropertyInfo), '("buffer", Gtk.TextView.TextViewBufferPropertyInfo), '("canDefault", Gtk.Widget.WidgetCanDefaultPropertyInfo), '("canFocus", Gtk.Widget.WidgetCanFocusPropertyInfo), '("child", Gtk.Container.ContainerChildPropertyInfo), '("completion", GtkSource.View.ViewCompletionPropertyInfo), '("compositeChild", Gtk.Widget.WidgetCompositeChildPropertyInfo), '("cursorVisible", Gtk.TextView.TextViewCursorVisiblePropertyInfo), '("doubleBuffered", Gtk.Widget.WidgetDoubleBufferedPropertyInfo), '("drawSpaces", GtkSource.View.ViewDrawSpacesPropertyInfo), '("editable", Gtk.TextView.TextViewEditablePropertyInfo), '("events", Gtk.Widget.WidgetEventsPropertyInfo), '("expand", Gtk.Widget.WidgetExpandPropertyInfo), '("focusOnClick", Gtk.Widget.WidgetFocusOnClickPropertyInfo), '("fontDesc", MapFontDescPropertyInfo), '("hadjustment", Gtk.Scrollable.ScrollableHadjustmentPropertyInfo), '("halign", Gtk.Widget.WidgetHalignPropertyInfo), '("hasDefault", Gtk.Widget.WidgetHasDefaultPropertyInfo), '("hasFocus", Gtk.Widget.WidgetHasFocusPropertyInfo), '("hasTooltip", Gtk.Widget.WidgetHasTooltipPropertyInfo), '("heightRequest", Gtk.Widget.WidgetHeightRequestPropertyInfo), '("hexpand", Gtk.Widget.WidgetHexpandPropertyInfo), '("hexpandSet", Gtk.Widget.WidgetHexpandSetPropertyInfo), '("highlightCurrentLine", GtkSource.View.ViewHighlightCurrentLinePropertyInfo), '("hscrollPolicy", Gtk.Scrollable.ScrollableHscrollPolicyPropertyInfo), '("imModule", Gtk.TextView.TextViewImModulePropertyInfo), '("indent", Gtk.TextView.TextViewIndentPropertyInfo), '("indentOnTab", GtkSource.View.ViewIndentOnTabPropertyInfo), '("indentWidth", GtkSource.View.ViewIndentWidthPropertyInfo), '("inputHints", Gtk.TextView.TextViewInputHintsPropertyInfo), '("inputPurpose", Gtk.TextView.TextViewInputPurposePropertyInfo), '("insertSpacesInsteadOfTabs", GtkSource.View.ViewInsertSpacesInsteadOfTabsPropertyInfo), '("isFocus", Gtk.Widget.WidgetIsFocusPropertyInfo), '("justification", Gtk.TextView.TextViewJustificationPropertyInfo), '("leftMargin", Gtk.TextView.TextViewLeftMarginPropertyInfo), '("margin", Gtk.Widget.WidgetMarginPropertyInfo), '("marginBottom", Gtk.Widget.WidgetMarginBottomPropertyInfo), '("marginEnd", Gtk.Widget.WidgetMarginEndPropertyInfo), '("marginLeft", Gtk.Widget.WidgetMarginLeftPropertyInfo), '("marginRight", Gtk.Widget.WidgetMarginRightPropertyInfo), '("marginStart", Gtk.Widget.WidgetMarginStartPropertyInfo), '("marginTop", Gtk.Widget.WidgetMarginTopPropertyInfo), '("monospace", Gtk.TextView.TextViewMonospacePropertyInfo), '("name", Gtk.Widget.WidgetNamePropertyInfo), '("noShowAll", Gtk.Widget.WidgetNoShowAllPropertyInfo), '("opacity", Gtk.Widget.WidgetOpacityPropertyInfo), '("overwrite", Gtk.TextView.TextViewOverwritePropertyInfo), '("parent", Gtk.Widget.WidgetParentPropertyInfo), '("pixelsAboveLines", Gtk.TextView.TextViewPixelsAboveLinesPropertyInfo), '("pixelsBelowLines", Gtk.TextView.TextViewPixelsBelowLinesPropertyInfo), '("pixelsInsideWrap", Gtk.TextView.TextViewPixelsInsideWrapPropertyInfo), '("populateAll", Gtk.TextView.TextViewPopulateAllPropertyInfo), '("receivesDefault", Gtk.Widget.WidgetReceivesDefaultPropertyInfo), '("resizeMode", Gtk.Container.ContainerResizeModePropertyInfo), '("rightMargin", Gtk.TextView.TextViewRightMarginPropertyInfo), '("rightMarginPosition", GtkSource.View.ViewRightMarginPositionPropertyInfo), '("scaleFactor", Gtk.Widget.WidgetScaleFactorPropertyInfo), '("sensitive", Gtk.Widget.WidgetSensitivePropertyInfo), '("showLineMarks", GtkSource.View.ViewShowLineMarksPropertyInfo), '("showLineNumbers", GtkSource.View.ViewShowLineNumbersPropertyInfo), '("showRightMargin", GtkSource.View.ViewShowRightMarginPropertyInfo), '("smartBackspace", GtkSource.View.ViewSmartBackspacePropertyInfo), '("smartHomeEnd", GtkSource.View.ViewSmartHomeEndPropertyInfo), '("spaceDrawer", GtkSource.View.ViewSpaceDrawerPropertyInfo), '("style", Gtk.Widget.WidgetStylePropertyInfo), '("tabWidth", GtkSource.View.ViewTabWidthPropertyInfo), '("tabs", Gtk.TextView.TextViewTabsPropertyInfo), '("tooltipMarkup", Gtk.Widget.WidgetTooltipMarkupPropertyInfo), '("tooltipText", Gtk.Widget.WidgetTooltipTextPropertyInfo), '("topMargin", Gtk.TextView.TextViewTopMarginPropertyInfo), '("vadjustment", Gtk.Scrollable.ScrollableVadjustmentPropertyInfo), '("valign", Gtk.Widget.WidgetValignPropertyInfo), '("vexpand", Gtk.Widget.WidgetVexpandPropertyInfo), '("vexpandSet", Gtk.Widget.WidgetVexpandSetPropertyInfo), '("view", MapViewPropertyInfo), '("visible", Gtk.Widget.WidgetVisiblePropertyInfo), '("vscrollPolicy", Gtk.Scrollable.ScrollableVscrollPolicyPropertyInfo), '("widthRequest", Gtk.Widget.WidgetWidthRequestPropertyInfo), '("window", Gtk.Widget.WidgetWindowPropertyInfo), '("wrapMode", Gtk.TextView.TextViewWrapModePropertyInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
mapFontDesc :: AttrLabelProxy "fontDesc"
mapFontDesc = AttrLabelProxy

mapView :: AttrLabelProxy "view"
mapView = AttrLabelProxy

#endif

#if ENABLE_OVERLOADING
type instance O.SignalList Map = MapSignalList
type MapSignalList = ('[ '("accelClosuresChanged", Gtk.Widget.WidgetAccelClosuresChangedSignalInfo), '("add", Gtk.Container.ContainerAddSignalInfo), '("backspace", Gtk.TextView.TextViewBackspaceSignalInfo), '("buttonPressEvent", Gtk.Widget.WidgetButtonPressEventSignalInfo), '("buttonReleaseEvent", Gtk.Widget.WidgetButtonReleaseEventSignalInfo), '("canActivateAccel", Gtk.Widget.WidgetCanActivateAccelSignalInfo), '("changeCase", GtkSource.View.ViewChangeCaseSignalInfo), '("changeNumber", GtkSource.View.ViewChangeNumberSignalInfo), '("checkResize", Gtk.Container.ContainerCheckResizeSignalInfo), '("childNotify", Gtk.Widget.WidgetChildNotifySignalInfo), '("compositedChanged", Gtk.Widget.WidgetCompositedChangedSignalInfo), '("configureEvent", Gtk.Widget.WidgetConfigureEventSignalInfo), '("copyClipboard", Gtk.TextView.TextViewCopyClipboardSignalInfo), '("cutClipboard", Gtk.TextView.TextViewCutClipboardSignalInfo), '("damageEvent", Gtk.Widget.WidgetDamageEventSignalInfo), '("deleteEvent", Gtk.Widget.WidgetDeleteEventSignalInfo), '("deleteFromCursor", Gtk.TextView.TextViewDeleteFromCursorSignalInfo), '("destroy", Gtk.Widget.WidgetDestroySignalInfo), '("destroyEvent", Gtk.Widget.WidgetDestroyEventSignalInfo), '("directionChanged", Gtk.Widget.WidgetDirectionChangedSignalInfo), '("dragBegin", Gtk.Widget.WidgetDragBeginSignalInfo), '("dragDataDelete", Gtk.Widget.WidgetDragDataDeleteSignalInfo), '("dragDataGet", Gtk.Widget.WidgetDragDataGetSignalInfo), '("dragDataReceived", Gtk.Widget.WidgetDragDataReceivedSignalInfo), '("dragDrop", Gtk.Widget.WidgetDragDropSignalInfo), '("dragEnd", Gtk.Widget.WidgetDragEndSignalInfo), '("dragFailed", Gtk.Widget.WidgetDragFailedSignalInfo), '("dragLeave", Gtk.Widget.WidgetDragLeaveSignalInfo), '("dragMotion", Gtk.Widget.WidgetDragMotionSignalInfo), '("draw", Gtk.Widget.WidgetDrawSignalInfo), '("enterNotifyEvent", Gtk.Widget.WidgetEnterNotifyEventSignalInfo), '("event", Gtk.Widget.WidgetEventSignalInfo), '("eventAfter", Gtk.Widget.WidgetEventAfterSignalInfo), '("extendSelection", Gtk.TextView.TextViewExtendSelectionSignalInfo), '("focus", Gtk.Widget.WidgetFocusSignalInfo), '("focusInEvent", Gtk.Widget.WidgetFocusInEventSignalInfo), '("focusOutEvent", Gtk.Widget.WidgetFocusOutEventSignalInfo), '("grabBrokenEvent", Gtk.Widget.WidgetGrabBrokenEventSignalInfo), '("grabFocus", Gtk.Widget.WidgetGrabFocusSignalInfo), '("grabNotify", Gtk.Widget.WidgetGrabNotifySignalInfo), '("hide", Gtk.Widget.WidgetHideSignalInfo), '("hierarchyChanged", Gtk.Widget.WidgetHierarchyChangedSignalInfo), '("insertAtCursor", Gtk.TextView.TextViewInsertAtCursorSignalInfo), '("insertEmoji", Gtk.TextView.TextViewInsertEmojiSignalInfo), '("joinLines", GtkSource.View.ViewJoinLinesSignalInfo), '("keyPressEvent", Gtk.Widget.WidgetKeyPressEventSignalInfo), '("keyReleaseEvent", Gtk.Widget.WidgetKeyReleaseEventSignalInfo), '("keynavFailed", Gtk.Widget.WidgetKeynavFailedSignalInfo), '("leaveNotifyEvent", Gtk.Widget.WidgetLeaveNotifyEventSignalInfo), '("lineMarkActivated", GtkSource.View.ViewLineMarkActivatedSignalInfo), '("map", Gtk.Widget.WidgetMapSignalInfo), '("mapEvent", Gtk.Widget.WidgetMapEventSignalInfo), '("mnemonicActivate", Gtk.Widget.WidgetMnemonicActivateSignalInfo), '("motionNotifyEvent", Gtk.Widget.WidgetMotionNotifyEventSignalInfo), '("moveCursor", Gtk.TextView.TextViewMoveCursorSignalInfo), '("moveFocus", Gtk.Widget.WidgetMoveFocusSignalInfo), '("moveLines", GtkSource.View.ViewMoveLinesSignalInfo), '("moveToMatchingBracket", GtkSource.View.ViewMoveToMatchingBracketSignalInfo), '("moveViewport", Gtk.TextView.TextViewMoveViewportSignalInfo), '("moveWords", GtkSource.View.ViewMoveWordsSignalInfo), '("notify", GObject.Object.ObjectNotifySignalInfo), '("parentSet", Gtk.Widget.WidgetParentSetSignalInfo), '("pasteClipboard", Gtk.TextView.TextViewPasteClipboardSignalInfo), '("populatePopup", Gtk.TextView.TextViewPopulatePopupSignalInfo), '("popupMenu", Gtk.Widget.WidgetPopupMenuSignalInfo), '("preeditChanged", Gtk.TextView.TextViewPreeditChangedSignalInfo), '("propertyNotifyEvent", Gtk.Widget.WidgetPropertyNotifyEventSignalInfo), '("proximityInEvent", Gtk.Widget.WidgetProximityInEventSignalInfo), '("proximityOutEvent", Gtk.Widget.WidgetProximityOutEventSignalInfo), '("queryTooltip", Gtk.Widget.WidgetQueryTooltipSignalInfo), '("realize", Gtk.Widget.WidgetRealizeSignalInfo), '("redo", GtkSource.View.ViewRedoSignalInfo), '("remove", Gtk.Container.ContainerRemoveSignalInfo), '("screenChanged", Gtk.Widget.WidgetScreenChangedSignalInfo), '("scrollEvent", Gtk.Widget.WidgetScrollEventSignalInfo), '("selectAll", Gtk.TextView.TextViewSelectAllSignalInfo), '("selectionClearEvent", Gtk.Widget.WidgetSelectionClearEventSignalInfo), '("selectionGet", Gtk.Widget.WidgetSelectionGetSignalInfo), '("selectionNotifyEvent", Gtk.Widget.WidgetSelectionNotifyEventSignalInfo), '("selectionReceived", Gtk.Widget.WidgetSelectionReceivedSignalInfo), '("selectionRequestEvent", Gtk.Widget.WidgetSelectionRequestEventSignalInfo), '("setAnchor", Gtk.TextView.TextViewSetAnchorSignalInfo), '("setFocusChild", Gtk.Container.ContainerSetFocusChildSignalInfo), '("show", Gtk.Widget.WidgetShowSignalInfo), '("showCompletion", GtkSource.View.ViewShowCompletionSignalInfo), '("showHelp", Gtk.Widget.WidgetShowHelpSignalInfo), '("sizeAllocate", Gtk.Widget.WidgetSizeAllocateSignalInfo), '("smartHomeEnd", GtkSource.View.ViewSmartHomeEndSignalInfo), '("stateChanged", Gtk.Widget.WidgetStateChangedSignalInfo), '("stateFlagsChanged", Gtk.Widget.WidgetStateFlagsChangedSignalInfo), '("styleSet", Gtk.Widget.WidgetStyleSetSignalInfo), '("styleUpdated", Gtk.Widget.WidgetStyleUpdatedSignalInfo), '("toggleCursorVisible", Gtk.TextView.TextViewToggleCursorVisibleSignalInfo), '("toggleOverwrite", Gtk.TextView.TextViewToggleOverwriteSignalInfo), '("touchEvent", Gtk.Widget.WidgetTouchEventSignalInfo), '("undo", GtkSource.View.ViewUndoSignalInfo), '("unmap", Gtk.Widget.WidgetUnmapSignalInfo), '("unmapEvent", Gtk.Widget.WidgetUnmapEventSignalInfo), '("unrealize", Gtk.Widget.WidgetUnrealizeSignalInfo), '("visibilityNotifyEvent", Gtk.Widget.WidgetVisibilityNotifyEventSignalInfo), '("windowStateEvent", Gtk.Widget.WidgetWindowStateEventSignalInfo)] :: [(Symbol, *)])

#endif

-- method Map::new
-- method type : Constructor
-- Args : []
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "GtkSource", name = "Map"}))
-- throws : False
-- Skip return : False

foreign import ccall "gtk_source_map_new" gtk_source_map_new :: 
    IO (Ptr Map)

{- |
Creates a new 'GI.GtkSource.Objects.Map.Map'.

/Since: 3.18/
-}
mapNew ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    m Map
    {- ^ __Returns:__ a new 'GI.GtkSource.Objects.Map.Map'. -}
mapNew  = liftIO $ do
    result <- gtk_source_map_new
    checkUnexpectedReturnNULL "mapNew" result
    result' <- (newObject Map) result
    return result'

#if ENABLE_OVERLOADING
#endif

-- method Map::get_view
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "map", argType = TInterface (Name {namespace = "GtkSource", name = "Map"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GtkSourceMap.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "GtkSource", name = "View"}))
-- throws : False
-- Skip return : False

foreign import ccall "gtk_source_map_get_view" gtk_source_map_get_view :: 
    Ptr Map ->                              -- map : TInterface (Name {namespace = "GtkSource", name = "Map"})
    IO (Ptr GtkSource.View.View)

{- |
Gets the 'GI.GtkSource.Objects.Map.Map':@/view/@ property, which is the view this widget is mapping.

/Since: 3.18/
-}
mapGetView ::
    (B.CallStack.HasCallStack, MonadIO m, IsMap a) =>
    a
    {- ^ /@map@/: a 'GI.GtkSource.Objects.Map.Map'. -}
    -> m (Maybe GtkSource.View.View)
    {- ^ __Returns:__ a 'GI.GtkSource.Objects.View.View' or 'Nothing'. -}
mapGetView map_ = liftIO $ do
    map_' <- unsafeManagedPtrCastPtr map_
    result <- gtk_source_map_get_view map_'
    maybeResult <- convertIfNonNull result $ \result' -> do
        result'' <- (newObject GtkSource.View.View) result'
        return result''
    touchManagedPtr map_
    return maybeResult

#if ENABLE_OVERLOADING
data MapGetViewMethodInfo
instance (signature ~ (m (Maybe GtkSource.View.View)), MonadIO m, IsMap a) => O.MethodInfo MapGetViewMethodInfo a signature where
    overloadedMethod _ = mapGetView

#endif

-- method Map::set_view
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "map", argType = TInterface (Name {namespace = "GtkSource", name = "Map"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GtkSourceMap", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "view", argType = TInterface (Name {namespace = "GtkSource", name = "View"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GtkSourceView", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "gtk_source_map_set_view" gtk_source_map_set_view :: 
    Ptr Map ->                              -- map : TInterface (Name {namespace = "GtkSource", name = "Map"})
    Ptr GtkSource.View.View ->              -- view : TInterface (Name {namespace = "GtkSource", name = "View"})
    IO ()

{- |
Sets the view that /@map@/ will be doing the mapping to.

/Since: 3.18/
-}
mapSetView ::
    (B.CallStack.HasCallStack, MonadIO m, IsMap a, GtkSource.View.IsView b) =>
    a
    {- ^ /@map@/: a 'GI.GtkSource.Objects.Map.Map' -}
    -> b
    {- ^ /@view@/: a 'GI.GtkSource.Objects.View.View' -}
    -> m ()
mapSetView map_ view = liftIO $ do
    map_' <- unsafeManagedPtrCastPtr map_
    view' <- unsafeManagedPtrCastPtr view
    gtk_source_map_set_view map_' view'
    touchManagedPtr map_
    touchManagedPtr view
    return ()

#if ENABLE_OVERLOADING
data MapSetViewMethodInfo
instance (signature ~ (b -> m ()), MonadIO m, IsMap a, GtkSource.View.IsView b) => O.MethodInfo MapSetViewMethodInfo a signature where
    overloadedMethod _ = mapSetView

#endif


